#ifndef LIBWTREF_H
#define LIBWTREF_H

#include <stdio.h>
#include <welltype/wtruntime.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef void (*LIBWTREF_PFN_ERROR_CB)(void* priv, const char* msg,
	wt_error err);

struct libwtref_segments
{
	struct vmmu32_segment* vma_segs;
	size_t                 vma_nsegs;
	wt_u32                 vma_szsh;
	wt_u32                 heap_start;
	wt_u32                 heap_size;
	wt_u32                 heap_gran;
};

extern const struct wtr_hashalg libwtref_hash_algs[];

int libwtref_segments_create(struct libwtref_segments* const segs,
	wt_u32 heap_size, wt_u32 gran_hint);

void libwtref_segments_destroy(struct libwtref_segments* const segs);

wt_error libwtref_init(struct wtr_vm* const vm, LIBWTREF_PFN_ERROR_CB errcb,
	void* errcb_priv);

wt_error libwtref_set_loader_ops(struct wtr_vm* const vm, FILE* const out);

wt_bool libwtref_run_vm(struct wtr_vm* const vm,
	struct wtr_context* const ctx, LIBWTREF_PFN_ERROR_CB errcb,
	void* errcb_priv, wt_u32* const retc, wt_u32 retmax, wt_value* retv);

void libwtref_handle_iocall(struct wtr_vm* const vm,
	struct wtr_context* const ctx, LIBWTREF_PFN_ERROR_CB errcb,
	void* errcb_priv);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* LIBWTREF_H */
