/* $Id: ast_raisestatement.h 6310 2023-01-16 20:39:48Z aron $ */
/*
    Welltype parser and AST
    Copyright (C) 2014-2023  Aron Barath

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WTPARSER_AST_RAISESTATEMENT_H
#define WTPARSER_AST_RAISESTATEMENT_H

#include "../astnode.h"
#include "ast_statement.h"
#include "../uniqueid.h"
#include <string>

namespace wtast
{

class RaiseStatement : public Statement
{
	std::string        mException;
	wtparser::UniqueId mUniqueId;
	bool               mIsNear;

public:
	RaiseStatement(const std::string & exc, wtparser::UniqueId unique_id, bool is_near)
		: Statement()
		, mException(exc)
		, mUniqueId(unique_id)
		, mIsNear(is_near)
	{
		// ok
	}

	~RaiseStatement()
	{
		// ok
	}

	void Accept(AstVisitor* vis);

	RaiseStatement* Copy();

	Kind GetKind() const
	{
		return RAISESTATEMENT;
	}

	const std::string & GetException() const
	{
		return mException;
	}

	wtparser::UniqueId GetUniqueId() const
	{
		return mUniqueId;
	}

	bool IsNear() const
	{
		return mIsNear;
	}
};

} // namespace wtast

#endif // WTPARSER_AST_RAISESTATEMENT_H
