/* $Id: ast_recorddeclaration.h 6310 2023-01-16 20:39:48Z aron $ */
/*
    Welltype parser and AST
    Copyright (C) 2014-2023  Aron Barath

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WTPARSER_AST_RECORDDECLARATION_H
#define WTPARSER_AST_RECORDDECLARATION_H

#include "../astnode.h"
#include "ast_declaration.h"

namespace wtast
{

class RecordType;

class RecordDeclaration : public Declaration
{
	RecordType* mRecord;

public:
	RecordDeclaration(RecordType* rec)
		: Declaration()
		, mRecord(rec)
	{
		// ok
	}

	~RecordDeclaration();

	void Accept(AstVisitor* vis);

	RecordDeclaration* Copy();

	Kind GetKind() const
	{
		return RECORDDECLARATION;
	}

	RecordType* GetRecord()
	{
		return mRecord;
	}
};

} // namespace wtast

#endif // WTPARSER_AST_RECORDDECLARATION_H
