#include "config_private.h"
#include "byteorder.h"

#define __SWAP_16(_short_) ((wt_u16)( \
		(((wt_u16)(_short_))>>8) | \
		(((wt_u16)(_short_))<<8)  \
	))

#define __SWAP_32(_int_) ((wt_u32)( \
		(((wt_u32)(_int_))<<24) | \
		((((wt_u32)(_int_))<<8) & 0x00ff0000ul) | \
		((((wt_u32)(_int_))>>8) & 0x0000ff00ul) | \
		(((wt_u32)(_int_))>>24) \
	))

#define __SWAP_64(_long_) ((wt_u64)( \
		(((wt_u64)(_long_))<<(8*7)) | \
		((((wt_u64)(_long_))<<(8*5)) & 0x00ff000000000000ull) | \
		((((wt_u64)(_long_))<<(8*3)) & 0x0000ff0000000000ull) | \
		((((wt_u64)(_long_))<<(8*1)) & 0x000000ff00000000ull) | \
		((((wt_u64)(_long_))>>(8*1)) & 0x00000000ff000000ull) | \
		((((wt_u64)(_long_))>>(8*3)) & 0x0000000000ff0000ull) | \
		((((wt_u64)(_long_))>>(8*5)) & 0x000000000000ff00ull) | \
		(((wt_u64)(_long_))>>(8*7)) \
	))

wt_bo wtr_byteorder()
{
	static union bint_t
	{
		wt_u32 i;
		wt_u8  b[4];
	} bint = { (wt_u32)0x02030401u };

	return bint.b[0];
}

wt_u16 wtr_swap16(wt_u16 x)
{
	return __SWAP_16(x);
}

wt_u32 wtr_swap32(wt_u32 x)
{
	return __SWAP_32(x);
}

wt_u64 wtr_swap64(wt_u64 x)
{
	return __SWAP_64(x);
}

wt_u16 wtr_botoh16(wt_u16 x, wt_bo bo)
{
	if(bo==wtr_byteorder())
	{
		return x;
	}

	return __SWAP_16(x);
}

wt_u32 wtr_botoh32(wt_u32 x, wt_bo bo)
{
	if(bo==wtr_byteorder())
	{
		return x;
	}

	return __SWAP_32(x);
}

wt_u64 wtr_botoh64(wt_u64 x, wt_bo bo)
{
	if(bo==wtr_byteorder())
	{
		return x;
	}

	return __SWAP_64(x);
}

wt_u16 wtr_htobo16(wt_u16 x, wt_bo bo)
{
	if(bo==wtr_byteorder())
	{
		return x;
	}

	return __SWAP_16(x);
}

wt_u32 wtr_htobo32(wt_u32 x, wt_bo bo)
{
	if(bo==wtr_byteorder())
	{
		return x;
	}

	return __SWAP_32(x);
}

wt_u64 wtr_htobo64(wt_u64 x, wt_bo bo)
{
	if(bo==wtr_byteorder())
	{
		return x;
	}

	return __SWAP_64(x);
}
