// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.





#include "parser.tab.hpp"


// Unqualified %code blocks.
#line 16 "parser.y"

int yylex(wtparser::WTParser::semantic_type* value, wtparser::WTParser::location_type* location, wtparser::ParserHelper & helper);

#line 50 "parser.tab.cpp"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 9 "parser.y"
namespace wtparser {
#line 143 "parser.tab.cpp"

  /// Build a parser object.
  WTParser::WTParser (ParserHelper & helper_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      helper (helper_yyarg)
  {}

  WTParser::~WTParser ()
  {}

  WTParser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  WTParser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  WTParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  WTParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (semantic_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}

  template <typename Base>
  WTParser::symbol_kind_type
  WTParser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  WTParser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  WTParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  WTParser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  WTParser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  WTParser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  WTParser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  WTParser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  WTParser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  WTParser::symbol_kind_type
  WTParser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  WTParser::symbol_kind_type
  WTParser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  WTParser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  WTParser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  WTParser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  WTParser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  WTParser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  WTParser::symbol_kind_type
  WTParser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  WTParser::stack_symbol_type::stack_symbol_type ()
  {}

  WTParser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  WTParser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  WTParser::stack_symbol_type&
  WTParser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  WTParser::stack_symbol_type&
  WTParser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  WTParser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YY_USE (yysym.kind ());
  }

#if YYDEBUG
  template <typename Base>
  void
  WTParser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  WTParser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  WTParser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  WTParser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  WTParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  WTParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  WTParser::debug_level_type
  WTParser::debug_level () const
  {
    return yydebug_;
  }

  void
  WTParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  WTParser::state_type
  WTParser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  WTParser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  WTParser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  WTParser::operator() ()
  {
    return parse ();
  }

  int
  WTParser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, helper));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // start: "end of file"
#line 302 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("start -> END");
		helper.mProgram = new wtast::Program();
	}
#line 613 "parser.tab.cpp"
    break;

  case 3: // start: entities "end of file"
#line 308 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("start -> entities END");
		helper.mProgram = new wtast::Program((yystack_[1].value.entities)->begin(), (yystack_[1].value.entities)->end());
		delete (yystack_[1].value.entities);
	}
#line 623 "parser.tab.cpp"
    break;

  case 4: // entities: entity
#line 317 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entities -> entity");
		(yylhs.value.entities) = new entities_t;

		if(helper.mDeclEntity)
		{
			(yylhs.value.entities)->push_back(helper.mDeclEntity);
			helper.mDeclEntity = 0;
		}

		(yylhs.value.entities)->push_back((yystack_[0].value.entity));
	}
#line 640 "parser.tab.cpp"
    break;

  case 5: // entities: entities entity
#line 331 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entities -> entities entity");

		if(helper.mDeclEntity)
		{
			(yylhs.value.entities)->push_back(helper.mDeclEntity);
			helper.mDeclEntity = 0;
		}

		(yylhs.value.entities)->push_back((yystack_[0].value.entity));
	}
#line 656 "parser.tab.cpp"
    break;

  case 6: // entity: metadata
#line 346 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entity -> metadata");
		(yylhs.value.entity) = (yystack_[0].value.metadata);
	}
#line 665 "parser.tab.cpp"
    break;

  case 7: // entity: block
#line 352 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entity -> block");
		(yylhs.value.entity) = (yystack_[0].value.block);
	}
#line 674 "parser.tab.cpp"
    break;

  case 8: // $@1: %empty
#line 358 "parser.y"
        {
		helper.mDeclEntity = new wtast::DeclareBlock(false, false);
	}
#line 682 "parser.tab.cpp"
    break;

  case 9: // entity: KW_DECLARE LBRACE $@1 declarations RBRACE
#line 362 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entity -> KW_DECLARE LBRACE declarations RBRACE");
		(yylhs.value.entity) = helper.mDeclEntity;
		helper.mDeclEntity = 0;
		delete (yystack_[1].value.declarations);
	}
#line 693 "parser.tab.cpp"
    break;

  case 10: // $@2: %empty
#line 370 "parser.y"
        {
		helper.mDeclEntity = new wtast::DeclareBlock(true, false);
	}
#line 701 "parser.tab.cpp"
    break;

  case 11: // entity: KW_IMPORT LBRACE $@2 declarations RBRACE
#line 374 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entity -> KW_IMPORT LBRACE declarations RBRACE");
		(yylhs.value.entity) = helper.mDeclEntity;
		helper.mDeclEntity = 0;
		delete (yystack_[1].value.declarations);
	}
#line 712 "parser.tab.cpp"
    break;

  case 12: // $@3: %empty
#line 382 "parser.y"
        {
		helper.mDeclEntity = new wtast::DeclareBlock(false, true);
	}
#line 720 "parser.tab.cpp"
    break;

  case 13: // entity: KW_EXPORT LBRACE $@3 declarations RBRACE
#line 386 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entity -> KW_EXPORT LBRACE declarations RBRACE");
		(yylhs.value.entity) = helper.mDeclEntity;
		helper.mDeclEntity = 0;
		delete (yystack_[1].value.declarations);
	}
#line 731 "parser.tab.cpp"
    break;

  case 14: // $@4: %empty
#line 394 "parser.y"
        {
		helper.SetCurrentVariableClass(wtast::AstNode::Variable::GLOBAL);
	}
#line 739 "parser.tab.cpp"
    break;

  case 15: // entity: KW_GLOBAL LBRACE $@4 variabledeclarations RBRACE
#line 398 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("entity -> KW_GLOBAL LBRACE variabledeclarations RBRACE");
		(yylhs.value.entity) = new wtast::GlobalBlock((yystack_[1].value.variabledecls)->begin(), (yystack_[1].value.variabledecls)->end());
		helper.SetCurrentVariableClass(wtast::AstNode::Variable::LOCAL);
		delete (yystack_[1].value.variabledecls);
	}
#line 750 "parser.tab.cpp"
    break;

  case 16: // metadata: META_AUTHOR string
#line 408 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("metadata -> META_AUTHOR string");
		(yylhs.value.metadata) = new wtast::Metadata(WT_KEY_AUTHOR, *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 760 "parser.tab.cpp"
    break;

  case 17: // metadata: META_TITLE string
#line 415 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("metadata -> META_TITLE string");
		(yylhs.value.metadata) = new wtast::Metadata(WT_KEY_TITLE, *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 770 "parser.tab.cpp"
    break;

  case 18: // metadata: META_VERSION string
#line 422 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("metadata -> META_VERSION string");
		(yylhs.value.metadata) = new wtast::Metadata(WT_KEY_VERSION, *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 780 "parser.tab.cpp"
    break;

  case 19: // metadata: META_COPYRIGHT string
#line 429 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("metadata -> META_COPYRIGHT string");
		(yylhs.value.metadata) = new wtast::Metadata(WT_KEY_COPYRIGHT, *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 790 "parser.tab.cpp"
    break;

  case 20: // metadata: META_ID string
#line 436 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("metadata -> META_ID string");
		(yylhs.value.metadata) = new wtast::Metadata(WT_KEY_ID, *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 800 "parser.tab.cpp"
    break;

  case 21: // metadata: META_COMMENT string
#line 443 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("metadata -> META_COMMENT string");
		(yylhs.value.metadata) = new wtast::Metadata(WT_KEY_COMMENT, *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 810 "parser.tab.cpp"
    break;

  case 22: // metadata: META__CUSTOM string ASSIGN string
#line 450 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("metadata -> META__CUSTOM string ASSIGN string");
		(yylhs.value.metadata) = new wtast::Metadata(*(yystack_[2].value.str), *(yystack_[0].value.str));
		delete (yystack_[2].value.str);
		delete (yystack_[0].value.str);
	}
#line 821 "parser.tab.cpp"
    break;

  case 23: // string: stringlit
#line 460 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("string -> stringlit");
		(yylhs.value.str) = new std::string(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 831 "parser.tab.cpp"
    break;

  case 24: // string: stringlit string
#line 467 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("string -> stringlit string");
		(yylhs.value.str) = new std::string(*(yystack_[1].value.str) + *(yystack_[0].value.str));
		delete (yystack_[1].value.str);
		delete (yystack_[0].value.str);
	}
#line 842 "parser.tab.cpp"
    break;

  case 25: // stringlit: STRINGLIT
#line 477 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("stringlit -> STRINGLIT");
		(yylhs.value.str) = new std::string(helper.ParseString(*(yystack_[0].value.str)));
		delete (yystack_[0].value.str);
	}
#line 852 "parser.tab.cpp"
    break;

  case 26: // stringlit: PREDEF_FILE
#line 484 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_FILE");
		(yylhs.value.str) = new std::string(helper.FileAsString());
	}
#line 861 "parser.tab.cpp"
    break;

  case 27: // stringlit: PREDEF_LINE
#line 490 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_LINE");
		(yylhs.value.str) = new std::string(helper.LineAsString());
	}
#line 870 "parser.tab.cpp"
    break;

  case 28: // stringlit: PREDEF_DATE
#line 496 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_DATE");
		(yylhs.value.str) = new std::string(helper.DateAsString());
	}
#line 879 "parser.tab.cpp"
    break;

  case 29: // stringlit: PREDEF_TIME
#line 502 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_TIME");
		(yylhs.value.str) = new std::string(helper.TimeAsString());
	}
#line 888 "parser.tab.cpp"
    break;

  case 30: // stringlit: PREDEF_DATETIME
#line 508 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("stringlit -> PREDEF_DATETIME");
		(yylhs.value.str) = new std::string(helper.DateAsString() + " " + helper.TimeAsString());
	}
#line 897 "parser.tab.cpp"
    break;

  case 31: // $@5: %empty
#line 515 "parser.y"
                           { helper.EnterDistinguishedBlockMode(true); if(!helper.mSymTab.EnterBlock("main")) { helper.PostError("Out of memory."); } }
#line 903 "parser.tab.cpp"
    break;

  case 32: // block: KW_MAIN throptions $@5 exceptioncompound
#line 516 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("block -> KW_MAIN throptions exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveDistinguishedBlockMode();
		(yylhs.value.block) = new wtast::MainBlock((yystack_[0].value.exceptioncompound), (yystack_[2].value.throptions)->css, (yystack_[2].value.throptions)->dss);
		delete (yystack_[2].value.throptions);
	}
#line 915 "parser.tab.cpp"
    break;

  case 33: // $@6: %empty
#line 524 "parser.y"
                { helper.EnterDistinguishedBlockMode(true); if(!helper.mSymTab.EnterBlock("ctor")) { helper.PostError("Out of memory."); } }
#line 921 "parser.tab.cpp"
    break;

  case 34: // block: KW_CTOR $@6 exceptioncompound
#line 525 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("block -> KW_CTOR exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveDistinguishedBlockMode();
		(yylhs.value.block) = new wtast::ConstructorBlock((yystack_[0].value.exceptioncompound));
	}
#line 932 "parser.tab.cpp"
    break;

  case 35: // $@7: %empty
#line 532 "parser.y"
                { helper.EnterDistinguishedBlockMode(true); if(!helper.mSymTab.EnterBlock("dtor")) { helper.PostError("Out of memory."); } }
#line 938 "parser.tab.cpp"
    break;

  case 36: // block: KW_DTOR $@7 exceptioncompound
#line 533 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("block -> KW_DTOR exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveDistinguishedBlockMode();
		(yylhs.value.block) = new wtast::DestructorBlock((yystack_[0].value.exceptioncompound));
	}
#line 949 "parser.tab.cpp"
    break;

  case 37: // $@8: %empty
#line 541 "parser.y"
        {
		if(!helper.mSymTab.EnterBlock((yystack_[0].value.functionsignature)->GetName()))
		{
			helper.PostError("Out of memory.");
		}

		for(std::size_t idx=0,num=(yystack_[0].value.functionsignature)->GetArgc();idx<num;++idx)
		{
			wtast::FunctionArgument* arg = (yystack_[0].value.functionsignature)->GetArg(idx);

			arg->SetUniqueId(helper.CreateUniqueId());
			if(!helper.mSymTab.AddVariable(arg->GetType(), arg->GetName(), arg->GetUniqueId(), helper._GetEHandlerMode(), wtast::AstNode::Variable::FORMAL))
			{
				helper.PostError(std::string("Multiple variable declaration of '") + arg->GetName() + "'");
			}
		}

		helper.EnterCurrentFunction((yystack_[0].value.functionsignature));
	}
#line 973 "parser.tab.cpp"
    break;

  case 38: // block: functionsignature $@8 attributes precond postcond exceptioncompound
#line 561 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("block -> functionsignature precond postcond exceptioncompound");
		helper.mSymTab.LeaveBlock();
		helper.LeaveCurrentFunction();
		(yylhs.value.block) = helper.MakeFunctionDefinition((yystack_[5].value.functionsignature), (yystack_[2].value.precond), (yystack_[1].value.postcond), (yystack_[0].value.exceptioncompound));
	}
#line 984 "parser.tab.cpp"
    break;

  case 39: // attributes: %empty
#line 571 "parser.y"
        {
		//$$ = 0;
	}
#line 992 "parser.tab.cpp"
    break;

  case 40: // precond: %empty
#line 578 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("precond -> {empty}");
		(yylhs.value.precond) = 0;
	}
#line 1001 "parser.tab.cpp"
    break;

  case 41: // precond: KW_PRE LBRACE expression RBRACE
#line 584 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("precond -> KW_PRE LBRACE expression RBRACE");
		(yylhs.value.precond) = helper.MakePrecondition((yystack_[1].value.expression));
	}
#line 1010 "parser.tab.cpp"
    break;

  case 42: // postcond: %empty
#line 592 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("postcond -> {empty}");
		(yylhs.value.postcond) = 0;
	}
#line 1019 "parser.tab.cpp"
    break;

  case 43: // @9: %empty
#line 598 "parser.y"
        {
		(yylhs.value.variabledecls) = helper.AddPostcondRets((yystack_[1].value.identlist));
	}
#line 1027 "parser.tab.cpp"
    break;

  case 44: // @10: %empty
#line 602 "parser.y"
        {
		(yylhs.value.variabledecls) = helper.AddPostcondOlds((yystack_[1].value.identlist));
	}
#line 1035 "parser.tab.cpp"
    break;

  case 45: // postcond: KW_POST LPAR identlist_opt RPAR @9 LBRACE identlist_opt SEMICOLON @10 expression RBRACE
#line 606 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("postcond -> KW_POST LPAR identlist_opt RPAR LBRACE identlist_opt SEMICOLON expression RBRACE");
		variabledecls_t* rets = (yystack_[6].value.variabledecls);
		variabledecls_t* olds = (yystack_[2].value.variabledecls);
		(yylhs.value.postcond) = helper.MakePostcondition(rets, olds, (yystack_[1].value.expression));
		delete rets;
		delete olds;
	}
#line 1048 "parser.tab.cpp"
    break;

  case 46: // identlist: IDENTIFIER
#line 618 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("identlist -> IDENTIFIER");
		(yylhs.value.identlist) = new identlist_t;
		(yylhs.value.identlist)->push_back(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1059 "parser.tab.cpp"
    break;

  case 47: // identlist: identlist COMMA IDENTIFIER
#line 626 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("identlist -> identlist COMMA IDENTIFIER");
		(yylhs.value.identlist) = (yystack_[2].value.identlist);
		(yylhs.value.identlist)->push_back(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1070 "parser.tab.cpp"
    break;

  case 48: // identlist_opt: %empty
#line 636 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("identlist_opt -> {empty}");
		(yylhs.value.identlist) = 0;
	}
#line 1079 "parser.tab.cpp"
    break;

  case 49: // identlist_opt: identlist
#line 642 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("identlist_opt -> identlist");
		(yylhs.value.identlist) = (yystack_[0].value.identlist);
	}
#line 1088 "parser.tab.cpp"
    break;

  case 50: // declarations: %empty
#line 650 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declarations -> {empty}");
		(yylhs.value.declarations) = new declarations_t;
	}
#line 1097 "parser.tab.cpp"
    break;

  case 51: // declarations: declarations declaration
#line 656 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declarations -> declarations declaration");
		(yylhs.value.declarations) = (yystack_[1].value.declarations);

		if((yystack_[0].value.declaration))
		{
			(yylhs.value.declarations)->push_back((yystack_[0].value.declaration));
			helper.AddDeclaration((yystack_[0].value.declaration));
		}
	}
#line 1112 "parser.tab.cpp"
    break;

  case 52: // declaration: functionsignature SEMICOLON
#line 670 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> functionsignature SEMICOLON");
		(yylhs.value.declaration) = helper.MakeFunctionDeclaration((yystack_[1].value.functionsignature));
	}
#line 1121 "parser.tab.cpp"
    break;

  case 53: // declaration: KW_TYPE functionsignature SEMICOLON
#line 676 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_TYPE functionsignature SEMICOLON");
		(yylhs.value.declaration) = helper.MakeFunctionTypeDeclaration((yystack_[1].value.functionsignature));
	}
#line 1130 "parser.tab.cpp"
    break;

  case 54: // declaration: KW_RECORD IDENTIFIER LBRACE recordfields RBRACE
#line 682 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_RECORD IDENTIFIER LBRACE recordfields RBRACE");
		(yylhs.value.declaration) = helper.MakeRecordDeclaration(*(yystack_[3].value.str), *(yystack_[1].value.recordfields), false, false, false);
		delete (yystack_[3].value.str);
		delete (yystack_[1].value.recordfields);
	}
#line 1141 "parser.tab.cpp"
    break;

  case 55: // declaration: KW_PRIVATE KW_RECORD IDENTIFIER LBRACE recordfields RBRACE
#line 690 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_PRIVATE KW_RECORD IDENTIFIER LBRACE recordfields RBRACE");
		if(helper.mDeclEntity->IsExport())
		{
			(yylhs.value.declaration) = helper.MakeRecordDeclaration(*(yystack_[3].value.str), *(yystack_[1].value.recordfields), true, false, false);
		}
		else
		{
			helper.PostError("Cannot import private record with fields.");
			(yylhs.value.declaration) = 0;
		}
		delete (yystack_[3].value.str);
		delete (yystack_[1].value.recordfields);
	}
#line 1160 "parser.tab.cpp"
    break;

  case 56: // declaration: KW_PRIVATE KW_RECORD IDENTIFIER SEMICOLON
#line 706 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_PRIVATE KW_RECORD IDENTIFIER SEMICOLON");
		if(helper.mDeclEntity->IsImport())
		{
			recordfields_t no_fields;
			(yylhs.value.declaration) = helper.MakeRecordDeclaration(*(yystack_[1].value.str), no_fields, true, false, true);
		}
		else
		{
			helper.PostError("Cannot declare exportable private record without fields.");
			(yylhs.value.declaration) = 0;
		}
		delete (yystack_[1].value.str);
	}
#line 1179 "parser.tab.cpp"
    break;

  case 57: // declaration: KW_LIMITED KW_RECORD IDENTIFIER LBRACE recordfields RBRACE
#line 722 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_LIMITED KW_RECORD IDENTIFIER LBRACE recordfields RBRACE");
		if(helper.mDeclEntity->IsExport())
		{
			(yylhs.value.declaration) = helper.MakeRecordDeclaration(*(yystack_[3].value.str), *(yystack_[1].value.recordfields), false, true, false);
		}
		else
		{
			helper.PostError("Cannot import limited record with fields.");
			(yylhs.value.declaration) = 0;
		}
		delete (yystack_[3].value.str);
		delete (yystack_[1].value.recordfields);
	}
#line 1198 "parser.tab.cpp"
    break;

  case 58: // declaration: KW_LIMITED KW_RECORD IDENTIFIER SEMICOLON
#line 738 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_LIMITED KW_RECORD IDENTIFIER SEMICOLON");
		if(helper.mDeclEntity->IsImport())
		{
			recordfields_t no_fields;
			(yylhs.value.declaration) = helper.MakeRecordDeclaration(*(yystack_[1].value.str), no_fields, false, true, true);
		}
		else
		{
			helper.PostError("Cannot declare exportable limited record without fields.");
			(yylhs.value.declaration) = 0;
		}
		delete (yystack_[1].value.str);
	}
#line 1217 "parser.tab.cpp"
    break;

  case 59: // declaration: KW_EXCEPTION IDENTIFIER SEMICOLON
#line 754 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_EXCEPTION IDENTIFIER SEMICOLON");
		(yylhs.value.declaration) = helper.MakeExceptionDeclaration(*(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 1227 "parser.tab.cpp"
    break;

  case 60: // declaration: KW_OPERATOR UNBOUNDOPERATOR IDENTIFIER integer32 SEMICOLON
#line 761 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_OPERATOR UNBOUNDOPERATOR IDENTIFIER integer32 SEMICOLON");
		(yylhs.value.declaration) = helper.MakeOperatorDeclaration(*(yystack_[3].value.str), *(yystack_[2].value.str), (yystack_[1].value.integer32));
		delete (yystack_[3].value.str);
		delete (yystack_[2].value.str);
	}
#line 1238 "parser.tab.cpp"
    break;

  case 61: // declaration: KW_OPERATOR IDENTIFIER IDENTIFIER integer32 SEMICOLON
#line 769 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_OPERATOR IDENTIFIER IDENTIFIER integer32 SEMICOLON");
		(yylhs.value.declaration) = helper.MakeOperatorDeclaration(*(yystack_[3].value.str), *(yystack_[2].value.str), (yystack_[1].value.integer32));
		delete (yystack_[3].value.str);
		delete (yystack_[2].value.str);
	}
#line 1249 "parser.tab.cpp"
    break;

  case 62: // declaration: KW_OPERATOR string IDENTIFIER integer32 SEMICOLON
#line 777 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_OPERATOR string IDENTIFIER integer32 SEMICOLON");
		(yylhs.value.declaration) = helper.MakeOperatorDeclaration(*(yystack_[3].value.str), *(yystack_[2].value.str), (yystack_[1].value.integer32));
		delete (yystack_[3].value.str);
		delete (yystack_[2].value.str);
	}
#line 1260 "parser.tab.cpp"
    break;

  case 63: // declaration: KW_ALIAS IDENTIFIER type SEMICOLON
#line 785 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_ALIAS IDENTIFIER type SEMICOLON");
		(yylhs.value.declaration) = helper.MakeAliasDeclaration(*(yystack_[2].value.str), (yystack_[1].value.type));
		delete (yystack_[2].value.str);
	}
#line 1270 "parser.tab.cpp"
    break;

  case 64: // @11: %empty
#line 792 "parser.y"
        {
		wtast::DataType* datatype = helper.MakeDataType(*(yystack_[1].value.str));
		helper.SetCurrentDataType(datatype);
		(yylhs.value.datatype) = datatype;
	}
#line 1280 "parser.tab.cpp"
    break;

  case 65: // declaration: KW_DATATYPE IDENTIFIER LBRACE @11 datatypeconses RBRACE
#line 798 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_DATATYPE IDENTIFIER LBRACE datatypeconses RBRACE");
		wtast::DataType* datatype = (yystack_[2].value.datatype);
		(yylhs.value.declaration) = helper.MakeDataTypeDeclaration(datatype, *(yystack_[1].value.datatypeconses));
		helper.SetCurrentDataType(0);
		delete (yystack_[4].value.str);
		delete (yystack_[1].value.datatypeconses);
	}
#line 1293 "parser.tab.cpp"
    break;

  case 66: // @12: %empty
#line 808 "parser.y"
        {
		wtast::EnumType* enumtype = helper.MakeEnumType(*(yystack_[1].value.str));
		helper.SetCurrentEnumType(enumtype);
		(yylhs.value.enumtype) = enumtype;
	}
#line 1303 "parser.tab.cpp"
    break;

  case 67: // declaration: KW_ENUM IDENTIFIER LBRACE @12 enumerators RBRACE
#line 814 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("declaration -> KW_ENUM IDENTIFIER LBRACE enumerators RBRACE");
		wtast::EnumType* enumtype = (yystack_[2].value.enumtype);
		(yylhs.value.declaration) = helper.MakeEnumTypeDeclaration(enumtype, *(yystack_[1].value.enumerators));
		helper.SetCurrentEnumType(0);
		delete (yystack_[4].value.str);
		delete (yystack_[1].value.enumerators);
	}
#line 1316 "parser.tab.cpp"
    break;

  case 68: // recordfields: %empty
#line 826 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("recordfields -> {empty}");
		(yylhs.value.recordfields) = new recordfields_t;
	}
#line 1325 "parser.tab.cpp"
    break;

  case 69: // recordfields: recordfields recordfield
#line 832 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("recordfields -> recordfields recordfield");
		(yylhs.value.recordfields) = (yystack_[1].value.recordfields);
		(yylhs.value.recordfields)->push_back((yystack_[0].value.recordfield));
	}
#line 1335 "parser.tab.cpp"
    break;

  case 70: // recordfield: type IDENTIFIER SEMICOLON
#line 841 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("recordfield -> type IDENTIFIER SEMICOLON");
		(yylhs.value.recordfield) = helper.MakeRecordField((yystack_[2].value.type), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 1345 "parser.tab.cpp"
    break;

  case 71: // enumerators: enumerator
#line 850 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("enumerators -> enumerator");
		(yylhs.value.enumerators) = new enumerators_t;
		(yylhs.value.enumerators)->push_back((yystack_[0].value.enumerator));
	}
#line 1355 "parser.tab.cpp"
    break;

  case 72: // enumerators: enumerators COMMA enumerator
#line 857 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("enumerators -> enumerators COMMA enumerator");
		(yylhs.value.enumerators) = (yystack_[2].value.enumerators);
		(yylhs.value.enumerators)->push_back((yystack_[0].value.enumerator));
	}
#line 1365 "parser.tab.cpp"
    break;

  case 73: // enumerator: IDENTIFIER
#line 866 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("enumerator -> IDENTIFIER");
		(yylhs.value.enumerator) = helper.MakeEnumerator(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);		
	}
#line 1375 "parser.tab.cpp"
    break;

  case 74: // enumerator: SPECIALIDENT
#line 873 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("enumerator -> SPECIALIDENT");
		(yylhs.value.enumerator) = helper.MakeEnumerator(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);		
	}
#line 1385 "parser.tab.cpp"
    break;

  case 75: // datatypeconses: datatypecons
#line 882 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypeconses -> datatypecons");
		(yylhs.value.datatypeconses) = new datatypeconses_t;
		(yylhs.value.datatypeconses)->push_back((yystack_[0].value.datatypecons));
	}
#line 1395 "parser.tab.cpp"
    break;

  case 76: // datatypeconses: datatypeconses datatypecons
#line 889 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypeconses -> datatypeconses datatypecons");
		(yylhs.value.datatypeconses) = (yystack_[1].value.datatypeconses);
		(yylhs.value.datatypeconses)->push_back((yystack_[0].value.datatypecons));
	}
#line 1405 "parser.tab.cpp"
    break;

  case 77: // datatypeconsname: IDENTIFIER
#line 898 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypeconsname -> IDENTIFIER");
		(yylhs.value.str) = (yystack_[0].value.str);
	}
#line 1414 "parser.tab.cpp"
    break;

  case 78: // datatypeconsname: SPECIALIDENT
#line 904 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypeconsname -> SPECIALIDENT");
		(yylhs.value.str) = (yystack_[0].value.str);
	}
#line 1423 "parser.tab.cpp"
    break;

  case 79: // datatypecons: datatypeconsname SEMICOLON
#line 912 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypecons -> datatypeconsname SEMICOLON");
		(yylhs.value.datatypecons) = helper.MakeDataTypeCons(*(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 1433 "parser.tab.cpp"
    break;

  case 80: // datatypecons: KW_DEFAULT datatypeconsname SEMICOLON
#line 919 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypecons -> KW_DEFAULT datatypeconsname SEMICOLON");
		(yylhs.value.datatypecons) = helper.MakeDataTypeCons(*(yystack_[1].value.str));
		(yylhs.value.datatypecons)->SetDefault(true);
		delete (yystack_[1].value.str);
	}
#line 1444 "parser.tab.cpp"
    break;

  case 81: // datatypecons: datatypecons_builder SEMICOLON
#line 927 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypecons -> datatypecons_builder SEMICOLON");
		(yylhs.value.datatypecons) = (yystack_[1].value.datatypecons);
	}
#line 1453 "parser.tab.cpp"
    break;

  case 82: // datatypecons_builder: IDENTIFIER type
#line 935 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypecons_builder -> IDENTIFIER type");
		(yylhs.value.datatypecons) = helper.MakeDataTypeCons(*(yystack_[1].value.str));
		(yylhs.value.datatypecons)->AddTypeBack((yystack_[0].value.type));
		delete (yystack_[1].value.str);
	}
#line 1464 "parser.tab.cpp"
    break;

  case 83: // datatypecons_builder: datatypecons_builder COMMA type
#line 943 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("datatypecons_builder -> datatypecons_builder COMMA type");
		(yylhs.value.datatypecons) = (yystack_[2].value.datatypecons);
		(yylhs.value.datatypecons)->AddTypeBack((yystack_[0].value.type));
	}
#line 1474 "parser.tab.cpp"
    break;

  case 84: // $@13: %empty
#line 951 "parser.y"
                          { helper.EnterEHandlerMode(true); }
#line 1480 "parser.tab.cpp"
    break;

  case 85: // exceptioncompound: LBRACE statements $@13 ehandlers finally RBRACE
#line 952 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("exceptioncompound -> LBRACE statements ehandlers finally RBRACE");
		(yylhs.value.exceptioncompound) = new wtast::ExceptionCompound((yystack_[4].value.statements)->begin(), (yystack_[4].value.statements)->end(), (yystack_[2].value.ehandlers), (yystack_[1].value.finally));
		helper.LeaveEHandlerMode();
		delete (yystack_[4].value.statements);
	}
#line 1491 "parser.tab.cpp"
    break;

  case 86: // throptions: %empty
#line 962 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("throptions -> {empty}");
		(yylhs.value.throptions) = new throptions_t;
	}
#line 1500 "parser.tab.cpp"
    break;

  case 87: // throptions: LBRACKET throptionlist RBRACKET
#line 968 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("throptions -> LBRACKET throptionlist RBRACKET");
		(yylhs.value.throptions) = (yystack_[1].value.throptions);
	}
#line 1509 "parser.tab.cpp"
    break;

  case 88: // throptionlist: OPT_DSS integer32
#line 976 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("throptionlist -> OPT_DSS integer32");
		(yylhs.value.throptions) = new throptions_t;
		(yylhs.value.throptions)->dss = (wt_u32)(yystack_[0].value.integer32);
	}
#line 1519 "parser.tab.cpp"
    break;

  case 89: // throptionlist: OPT_CSS integer32
#line 983 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("throptionlist -> OPT_CSS integer32");
		(yylhs.value.throptions) = new throptions_t;
		(yylhs.value.throptions)->css = (wt_u32)(yystack_[0].value.integer32);
	}
#line 1529 "parser.tab.cpp"
    break;

  case 90: // throptionlist: throptionlist OPT_DSS integer32
#line 990 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("throptionlist -> throptionlist OPT_DSS integer32");
		(yylhs.value.throptions) = (yystack_[2].value.throptions);
		(yylhs.value.throptions)->dss = (wt_u32)(yystack_[0].value.integer32);
	}
#line 1539 "parser.tab.cpp"
    break;

  case 91: // throptionlist: throptionlist OPT_CSS integer32
#line 997 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("throptionlist -> throptionlist OPT_CSS integer32");
		(yylhs.value.throptions) = (yystack_[2].value.throptions);
		(yylhs.value.throptions)->css = (wt_u32)(yystack_[0].value.integer32);
	}
#line 1549 "parser.tab.cpp"
    break;

  case 92: // integer8: I8BIN
#line 1006 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer8 -> I8BIN");
		(yylhs.value.integer8) = helper.BinToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1559 "parser.tab.cpp"
    break;

  case 93: // integer8: I8OCT
#line 1013 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer8 -> I8OCT");
		(yylhs.value.integer8) = helper.OctToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1569 "parser.tab.cpp"
    break;

  case 94: // integer8: I8DEC
#line 1020 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer8 -> I8DEC");
		(yylhs.value.integer8) = helper.DecToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1579 "parser.tab.cpp"
    break;

  case 95: // integer8: I8HEX
#line 1027 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer8 -> I8HEX");
		(yylhs.value.integer8) = helper.HexToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1589 "parser.tab.cpp"
    break;

  case 96: // unsigned8: U8BIN
#line 1036 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8BIN");
		(yylhs.value.unsigned8) = helper.BinToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1599 "parser.tab.cpp"
    break;

  case 97: // unsigned8: U8OCT
#line 1043 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8OCT");
		(yylhs.value.unsigned8) = helper.OctToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1609 "parser.tab.cpp"
    break;

  case 98: // unsigned8: U8DEC
#line 1050 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8DEC");
		(yylhs.value.unsigned8) = helper.DecToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1619 "parser.tab.cpp"
    break;

  case 99: // unsigned8: U8HEX
#line 1057 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned8 -> U8HEX");
		(yylhs.value.unsigned8) = helper.HexToI8(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1629 "parser.tab.cpp"
    break;

  case 100: // integer16: I16BIN
#line 1066 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer16 -> I16BIN");
		(yylhs.value.integer16) = helper.BinToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1639 "parser.tab.cpp"
    break;

  case 101: // integer16: I16OCT
#line 1073 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer16 -> I16OCT");
		(yylhs.value.integer16) = helper.OctToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1649 "parser.tab.cpp"
    break;

  case 102: // integer16: I16DEC
#line 1080 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer16 -> I16DEC");
		(yylhs.value.integer16) = helper.DecToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1659 "parser.tab.cpp"
    break;

  case 103: // integer16: I16HEX
#line 1087 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer16 -> I16HEX");
		(yylhs.value.integer16) = helper.HexToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1669 "parser.tab.cpp"
    break;

  case 104: // unsigned16: U16BIN
#line 1096 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16BIN");
		(yylhs.value.unsigned16) = helper.BinToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1679 "parser.tab.cpp"
    break;

  case 105: // unsigned16: U16OCT
#line 1103 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16OCT");
		(yylhs.value.unsigned16) = helper.OctToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1689 "parser.tab.cpp"
    break;

  case 106: // unsigned16: U16DEC
#line 1110 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16DEC");
		(yylhs.value.unsigned16) = helper.DecToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1699 "parser.tab.cpp"
    break;

  case 107: // unsigned16: U16HEX
#line 1117 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned16 -> U16HEX");
		(yylhs.value.unsigned16) = helper.HexToI16(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1709 "parser.tab.cpp"
    break;

  case 108: // integer32: I32BIN
#line 1126 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer32 -> I32BIN");
		(yylhs.value.integer32) = helper.BinToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1719 "parser.tab.cpp"
    break;

  case 109: // integer32: I32OCT
#line 1133 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer32 -> I32OCT");
		(yylhs.value.integer32) = helper.OctToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1729 "parser.tab.cpp"
    break;

  case 110: // integer32: I32DEC
#line 1140 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer32 -> I32DEC");
		(yylhs.value.integer32) = helper.DecToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1739 "parser.tab.cpp"
    break;

  case 111: // integer32: I32HEX
#line 1147 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer32 -> I32HEX");
		(yylhs.value.integer32) = helper.HexToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1749 "parser.tab.cpp"
    break;

  case 112: // unsigned32: U32BIN
#line 1156 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32BIN");
		(yylhs.value.unsigned32) = helper.BinToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1759 "parser.tab.cpp"
    break;

  case 113: // unsigned32: U32OCT
#line 1163 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32OCT");
		(yylhs.value.unsigned32) = helper.OctToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1769 "parser.tab.cpp"
    break;

  case 114: // unsigned32: U32DEC
#line 1170 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32DEC");
		(yylhs.value.unsigned32) = helper.DecToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1779 "parser.tab.cpp"
    break;

  case 115: // unsigned32: U32HEX
#line 1177 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned32 -> U32HEX");
		(yylhs.value.unsigned32) = helper.HexToI32(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1789 "parser.tab.cpp"
    break;

  case 116: // integer64: I64BIN
#line 1186 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer64 -> I64BIN");
		(yylhs.value.integer64) = helper.BinToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1799 "parser.tab.cpp"
    break;

  case 117: // integer64: I64OCT
#line 1193 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer64 -> I64OCT");
		(yylhs.value.integer64) = helper.OctToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1809 "parser.tab.cpp"
    break;

  case 118: // integer64: I64DEC
#line 1200 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer64 -> I64DEC");
		(yylhs.value.integer64) = helper.DecToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1819 "parser.tab.cpp"
    break;

  case 119: // integer64: I64HEX
#line 1207 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("integer64 -> I64HEX");
		(yylhs.value.integer64) = helper.HexToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1829 "parser.tab.cpp"
    break;

  case 120: // unsigned64: U64BIN
#line 1216 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64BIN");
		(yylhs.value.unsigned64) = helper.BinToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1839 "parser.tab.cpp"
    break;

  case 121: // unsigned64: U64OCT
#line 1223 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64OCT");
		(yylhs.value.unsigned64) = helper.OctToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1849 "parser.tab.cpp"
    break;

  case 122: // unsigned64: U64DEC
#line 1230 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64DEC");
		(yylhs.value.unsigned64) = helper.DecToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1859 "parser.tab.cpp"
    break;

  case 123: // unsigned64: U64HEX
#line 1237 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("unsigned64 -> U64HEX");
		(yylhs.value.unsigned64) = helper.HexToI64(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 1869 "parser.tab.cpp"
    break;

  case 124: // ehandlers: %empty
#line 1246 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("ehandlers -> {empty}");
		(yylhs.value.ehandlers) = new wtast::EHandlers();
	}
#line 1878 "parser.tab.cpp"
    break;

  case 125: // ehandlers: ehandlerlist
#line 1252 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("ehandlers -> ehandlerlist");
		(yylhs.value.ehandlers) = new wtast::EHandlers((yystack_[0].value.ehandlerlist)->begin(), (yystack_[0].value.ehandlerlist)->end());
		delete (yystack_[0].value.ehandlerlist);
	}
#line 1888 "parser.tab.cpp"
    break;

  case 126: // ehandlerlist: KW_EXCEPTION LPAR DOTDOTDOT RPAR compound
#line 1261 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("ehandlerlist -> KW_EXCEPTION LPAR DOTDOTDOT RPAR compound");
		(yylhs.value.ehandlerlist) = new ehandlerlist_t;
		(yylhs.value.ehandlerlist)->push_front(new wtast::EHandler("...", (yystack_[0].value.compound)));
	}
#line 1898 "parser.tab.cpp"
    break;

  case 127: // ehandlerlist: KW_EXCEPTION LPAR IDENTIFIER RPAR compound
#line 1268 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("ehandlerlist -> KW_EXCEPTION LPAR IDENTIFIER RPAR compound");
		helper.EnterEHandlerMode(true);
		(yylhs.value.ehandlerlist) = new ehandlerlist_t;
		(yylhs.value.ehandlerlist)->push_front(new wtast::EHandler(*(yystack_[2].value.str), (yystack_[0].value.compound)));
		delete (yystack_[2].value.str);
	}
#line 1910 "parser.tab.cpp"
    break;

  case 128: // ehandlerlist: KW_EXCEPTION LPAR IDENTIFIER RPAR compound ehandlerlist
#line 1277 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("ehandlerlist -> KW_EXCEPTION LPAR IDENTIFIER RPAR compound ehandlerlist");
		(yylhs.value.ehandlerlist) = (yystack_[0].value.ehandlerlist);
		(yylhs.value.ehandlerlist)->push_front(new wtast::EHandler(*(yystack_[3].value.str), (yystack_[1].value.compound)));
		delete (yystack_[3].value.str);
	}
#line 1921 "parser.tab.cpp"
    break;

  case 129: // finally: %empty
#line 1287 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("finally -> {empty}");
		(yylhs.value.finally) = new wtast::Finally();
	}
#line 1930 "parser.tab.cpp"
    break;

  case 130: // $@14: %empty
#line 1292 "parser.y"
                   { helper.EnterFinallyMode(true); helper.EnterEHandlerMode(true); }
#line 1936 "parser.tab.cpp"
    break;

  case 131: // finally: KW_FINALLY $@14 compound
#line 1293 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("finally -> KW_FINALLY compound");
		helper.LeaveFinallyMode();
		helper.LeaveEHandlerMode();
		(yylhs.value.finally) = new wtast::Finally((yystack_[0].value.compound));
	}
#line 1947 "parser.tab.cpp"
    break;

  case 132: // functionargument: type IDENTIFIER
#line 1303 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("functionargument -> type IDENTIFIER");
		(yylhs.value.functionargument) = helper.MakeFunctionArgument((yystack_[1].value.type), *(yystack_[0].value.str), false);
		delete (yystack_[0].value.str);
	}
#line 1957 "parser.tab.cpp"
    break;

  case 133: // functionargument: KW_MUTABLE type IDENTIFIER
#line 1310 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("functionargument -> KW_MUTABLE type IDENTIFIER");
		(yylhs.value.functionargument) = helper.MakeFunctionArgument((yystack_[1].value.type), *(yystack_[0].value.str), true);
		delete (yystack_[0].value.str);
	}
#line 1967 "parser.tab.cpp"
    break;

  case 134: // functionsignature: funcsig_start RPAR
#line 1319 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("functionsignature -> funcsig_start RPAR");
		wtast::FunctionSignature* funcsig = (yystack_[1].value.functionsignature);
		funcsig->SetUniqueId(helper.GetFuncUniqueId(funcsig));
		(yylhs.value.functionsignature) = funcsig;
	}
#line 1978 "parser.tab.cpp"
    break;

  case 135: // functionsignature: funcsig_args RPAR
#line 1327 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("functionsignature -> funcsig_args RPAR");
		wtast::FunctionSignature* funcsig = (yystack_[1].value.functionsignature);
		funcsig->SetUniqueId(helper.GetFuncUniqueId(funcsig));
		(yylhs.value.functionsignature) = funcsig;
	}
#line 1989 "parser.tab.cpp"
    break;

  case 136: // functionsignature: funcsig_rets
#line 1335 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("functionsignature -> funcsig_rets");
		wtast::FunctionSignature* funcsig = (yystack_[0].value.functionsignature);
		funcsig->SetUniqueId(helper.GetFuncUniqueId(funcsig));
		(yylhs.value.functionsignature) = funcsig;
	}
#line 2000 "parser.tab.cpp"
    break;

  case 137: // funcsig_start: KW_FUNCTION IDENTIFIER LPAR
#line 1345 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_start -> FW_FUNCTION IDENTIFIER LPAR");
		(yylhs.value.functionsignature) = new wtast::FunctionSignature(*(yystack_[1].value.str), true);
		delete (yystack_[1].value.str);
	}
#line 2010 "parser.tab.cpp"
    break;

  case 138: // funcsig_start: KW_FUNCTION string LPAR
#line 1352 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_start -> FW_FUNCTION string LPAR");
		(yylhs.value.functionsignature) = new wtast::FunctionSignature(*(yystack_[1].value.str), true);
		delete (yystack_[1].value.str);
	}
#line 2020 "parser.tab.cpp"
    break;

  case 139: // funcsig_start: KW_PURE KW_FUNCTION IDENTIFIER LPAR
#line 1359 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_PURE FW_FUNCTION IDENTIFIER LPAR");
		(yylhs.value.functionsignature) = new wtast::FunctionSignature(*(yystack_[1].value.str), true);
		delete (yystack_[1].value.str);
	}
#line 2030 "parser.tab.cpp"
    break;

  case 140: // funcsig_start: KW_PURE KW_FUNCTION string LPAR
#line 1366 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_PURE FW_FUNCTION string LPAR");
		(yylhs.value.functionsignature) = new wtast::FunctionSignature(*(yystack_[1].value.str), true);
		delete (yystack_[1].value.str);
	}
#line 2040 "parser.tab.cpp"
    break;

  case 141: // funcsig_start: KW_IMPURE KW_FUNCTION IDENTIFIER LPAR
#line 1373 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_IMPURE FW_FUNCTION IDENTIFIER LPAR");
		(yylhs.value.functionsignature) = new wtast::FunctionSignature(*(yystack_[1].value.str), false);
		delete (yystack_[1].value.str);
	}
#line 2050 "parser.tab.cpp"
    break;

  case 142: // funcsig_start: KW_IMPURE KW_FUNCTION string LPAR
#line 1380 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_start -> KW_IMPURE FW_FUNCTION string LPAR");
		(yylhs.value.functionsignature) = new wtast::FunctionSignature(*(yystack_[1].value.str), false);
		delete (yystack_[1].value.str);
	}
#line 2060 "parser.tab.cpp"
    break;

  case 143: // funcsig_args: funcsig_start functionargument
#line 1389 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_args -> funcsig_start functionargument");
		(yylhs.value.functionsignature) = (yystack_[1].value.functionsignature);
		(yylhs.value.functionsignature)->AddArgBack((yystack_[0].value.functionargument));
	}
#line 2070 "parser.tab.cpp"
    break;

  case 144: // funcsig_args: funcsig_args COMMA functionargument
#line 1396 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_args -> funcsig_args COMMA functionargument");
		(yylhs.value.functionsignature) = (yystack_[2].value.functionsignature);
		(yylhs.value.functionsignature)->AddArgBack((yystack_[0].value.functionargument));
	}
#line 2080 "parser.tab.cpp"
    break;

  case 145: // funcsig_rets: funcsig_start RPAR COLON type
#line 1405 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_rets -> funcsig_start RPAR COLON type");
		(yylhs.value.functionsignature) = (yystack_[3].value.functionsignature);
		(yylhs.value.functionsignature)->AddRetBack((yystack_[0].value.type));
	}
#line 2090 "parser.tab.cpp"
    break;

  case 146: // funcsig_rets: funcsig_args RPAR COLON type
#line 1412 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_rets -> funcsig_args RPAR COLON type");
		(yylhs.value.functionsignature) = (yystack_[3].value.functionsignature);
		(yylhs.value.functionsignature)->AddRetBack((yystack_[0].value.type));
	}
#line 2100 "parser.tab.cpp"
    break;

  case 147: // funcsig_rets: funcsig_rets COMMA type
#line 1419 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funcsig_rets -> funcsig_rets COMMA type");
		(yylhs.value.functionsignature) = (yystack_[2].value.functionsignature);
		(yylhs.value.functionsignature)->AddRetBack((yystack_[0].value.type));
	}
#line 2110 "parser.tab.cpp"
    break;

  case 148: // $@15: %empty
#line 1427 "parser.y"
               { if(!helper.mSymTab.EnterBlock()) { helper.PostError("Out of memory."); } }
#line 2116 "parser.tab.cpp"
    break;

  case 149: // compound: LBRACE $@15 statements RBRACE
#line 1428 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("compound -> LBRACE statements RBRACE");
		(yylhs.value.compound) = new wtast::Compound((yystack_[1].value.statements)->begin(), (yystack_[1].value.statements)->end(), "");
		helper.mSymTab.LeaveBlock();
		delete (yystack_[1].value.statements);
	}
#line 2127 "parser.tab.cpp"
    break;

  case 150: // $@16: %empty
#line 1435 "parser.y"
                          { if(!helper.mSymTab.EnterBlock(*(yystack_[1].value.str))) { helper.PostError("Out of memory."); } }
#line 2133 "parser.tab.cpp"
    break;

  case 151: // compound: IDENTIFIER LBRACE $@16 statements RBRACE
#line 1436 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("compound -> IDENTIFIER LBRACE statements RBRACE");
		(yylhs.value.compound) = new wtast::Compound((yystack_[1].value.statements)->begin(), (yystack_[1].value.statements)->end(), *(yystack_[4].value.str));
		helper.mSymTab.LeaveBlock();
		delete (yystack_[4].value.str);
		delete (yystack_[1].value.statements);
	}
#line 2145 "parser.tab.cpp"
    break;

  case 152: // statements: %empty
#line 1447 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statements -> {empty}");
		(yylhs.value.statements) = new statements_t;
	}
#line 2154 "parser.tab.cpp"
    break;

  case 153: // statements: statement
#line 1453 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statements -> statement");
		(yylhs.value.statements) = new statements_t;
		if((yystack_[0].value.statement))
		{
			(yylhs.value.statements)->push_back((yystack_[0].value.statement));
		}
	}
#line 2167 "parser.tab.cpp"
    break;

  case 154: // statements: statements statement
#line 1463 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statements -> statements statement");
		(yylhs.value.statements) = (yystack_[1].value.statements);
		if((yystack_[0].value.statement))
		{
			(yylhs.value.statements)->push_back((yystack_[0].value.statement));
		}
	}
#line 2180 "parser.tab.cpp"
    break;

  case 155: // statement: variabledeclaration
#line 1475 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> variabledeclaration");
		(yylhs.value.statement) = (yystack_[0].value.variabledeclaration);
	}
#line 2189 "parser.tab.cpp"
    break;

  case 156: // statement: compound
#line 1481 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> compound");
		(yylhs.value.statement) = (yystack_[0].value.compound);
	}
#line 2198 "parser.tab.cpp"
    break;

  case 157: // statement: assignment SEMICOLON
#line 1487 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> assignment");
		(yylhs.value.statement) = (yystack_[1].value.assignment);
	}
#line 2207 "parser.tab.cpp"
    break;

  case 158: // statement: funccallexpr SEMICOLON
#line 1493 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> funccallexpr SEMICOLON");
		if(helper.ExpressionHasNoType((yystack_[1].value.expression)))
		{
			(yylhs.value.statement) = new wtast::ProcedureCall((yystack_[1].value.expression));
		}
		else
		{
			(yylhs.value.statement) = 0;
			helper.PostError("Function has return values, but not in assignment.");
		}
	}
#line 2224 "parser.tab.cpp"
    break;

  case 159: // statement: KW_RETURN SEMICOLON
#line 1507 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_RETURN SEMICOLON");
		(yylhs.value.statement) = helper.MakeReturnStatement(0);
	}
#line 2233 "parser.tab.cpp"
    break;

  case 160: // statement: KW_RETURN expression SEMICOLON
#line 1513 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_RETURN expression SEMICOLON");
		(yylhs.value.statement) = helper.MakeReturnStatement((yystack_[1].value.expression));
	}
#line 2242 "parser.tab.cpp"
    break;

  case 161: // statement: KW_RAISE LPAR IDENTIFIER RPAR SEMICOLON
#line 1519 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_RAISE LPAR IDENTIFIER RPAR SEMICOLON");
		(yylhs.value.statement) = helper.MakeRaiseStatement(*(yystack_[2].value.str), false);
		delete (yystack_[2].value.str);
	}
#line 2252 "parser.tab.cpp"
    break;

  case 162: // statement: KW_RAISENEAR LPAR IDENTIFIER RPAR SEMICOLON
#line 1526 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_RAISENEAR LPAR IDENTIFIER RPAR SEMICOLON");
		(yylhs.value.statement) = helper.MakeRaiseStatement(*(yystack_[2].value.str), true);
		delete (yystack_[2].value.str);
	}
#line 2262 "parser.tab.cpp"
    break;

  case 163: // statement: KW_WHILE LPAR expression RPAR compound
#line 1533 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_WHILE LPAR expression RPAR compound");
		(yylhs.value.statement) = helper.MakeWhileStatement((yystack_[2].value.expression), (yystack_[0].value.compound));
	}
#line 2271 "parser.tab.cpp"
    break;

  case 164: // statement: KW_DO compound KW_WHILE LPAR expression RPAR SEMICOLON
#line 1539 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_DO compound KW_WHILE LPAR expression RPAR SEMICOLON");
		(yylhs.value.statement) = helper.MakeDoWhileStatement((yystack_[5].value.compound), (yystack_[2].value.expression));
	}
#line 2280 "parser.tab.cpp"
    break;

  case 165: // statement: KW_FOR LPAR assignment_opt SEMICOLON expression_opt SEMICOLON assignment_opt RPAR compound
#line 1545 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_FOR LPAR assignment_opt SEMICOLON expression_opt SEMICOLON assignment_opt RPAR compound");
		(yylhs.value.statement) = helper.MakeForStatement((yystack_[6].value.assignment), (yystack_[4].value.expression), (yystack_[2].value.assignment), (yystack_[0].value.compound));
	}
#line 2289 "parser.tab.cpp"
    break;

  case 166: // @17: %empty
#line 1551 "parser.y"
        {
		(yylhs.value.variabledeclaration) = helper.EnterForeachBlock(*(yystack_[4].value.str), (yystack_[2].value.expression), true);
	}
#line 2297 "parser.tab.cpp"
    break;

  case 167: // statement: KW_FOREACH LPAR IDENTIFIER KW_IN expression DOTDOT expression @17 inclusive_opt reverse_opt foreach_while foreach_which RPAR compound
#line 1555 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_FOREACH LPAR IDENTIFIER KW_IN expression DOTDOT expression inclusive_opt reverse_opt foreach_while foreach_which RPAR compound");
		wtast::VariableDeclaration* vardecl = (yystack_[6].value.variabledeclaration);
		(yylhs.value.statement) = helper.MakeForeachStatement(vardecl, (yystack_[9].value.expression), (yystack_[7].value.expression), (yystack_[5].value.logical), (yystack_[4].value.logical), (yystack_[3].value.expression), (yystack_[2].value.expression), (yystack_[0].value.compound));
		if(vardecl)
		{
			helper.mSymTab.LeaveBlock();
		}
		delete (yystack_[11].value.str);
	}
#line 2312 "parser.tab.cpp"
    break;

  case 168: // @18: %empty
#line 1567 "parser.y"
        {
		(yylhs.value.variabledeclaration) = helper.EnterForeachBlock(*(yystack_[2].value.str), (yystack_[0].value.expression), false);
	}
#line 2320 "parser.tab.cpp"
    break;

  case 169: // statement: KW_FOREACH LPAR IDENTIFIER KW_IN expression @18 reverse_opt foreach_while foreach_which RPAR compound
#line 1571 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_FOREACH LPAR IDENTIFIER KW_IN expression reverse_opt foreach_while foreach_which RPAR compound");
		wtast::VariableDeclaration* vardecl = (yystack_[5].value.variabledeclaration);
		(yylhs.value.statement) = helper.MakeForeachStatement(vardecl, (yystack_[6].value.expression), (yystack_[4].value.logical), (yystack_[3].value.expression), (yystack_[2].value.expression), (yystack_[0].value.compound));
		if(vardecl)
		{
			helper.mSymTab.LeaveBlock();
		}
		delete (yystack_[8].value.str);
	}
#line 2335 "parser.tab.cpp"
    break;

  case 170: // statement: KW_IF LPAR expression RPAR compound elsestatement
#line 1583 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_IF LPAR expression RPAR compound elsestatement");
		(yylhs.value.statement) = helper.MakeIfStatement((yystack_[3].value.expression), (yystack_[1].value.compound), (yystack_[0].value.statement));
	}
#line 2344 "parser.tab.cpp"
    break;

  case 171: // statement: KW_ASSERT LPAR expression RPAR SEMICOLON
#line 1589 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_ASSERT LPAR expression RPAR SEMICOLON");
		(yylhs.value.statement) = helper.MakeAssertStatement((yystack_[2].value.expression));
	}
#line 2353 "parser.tab.cpp"
    break;

  case 172: // $@19: %empty
#line 1595 "parser.y"
        {
		helper.PushSwitchExpression((yystack_[1].value.expression));
	}
#line 2361 "parser.tab.cpp"
    break;

  case 173: // statement: KW_SWITCH LPAR expression RPAR $@19 LBRACE switchcases default_opt RBRACE
#line 1599 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("statement -> KW_SWITCH LPAR expression RPAR LBRACE switchcases default_opt RBRACE");
		(yylhs.value.statement) = helper.MakeSwitchStatement((yystack_[6].value.expression), (yystack_[2].value.switchcases), (yystack_[1].value.defaultstatement));
		helper.PopSwitchExpression();
	}
#line 2371 "parser.tab.cpp"
    break;

  case 174: // elsestatement: %empty
#line 1608 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("elsestatement -> {empty}");
		(yylhs.value.statement) = 0;
	}
#line 2380 "parser.tab.cpp"
    break;

  case 175: // elsestatement: KW_ELSE compound
#line 1614 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("elsestatement -> KW_ELSE compound");
		(yylhs.value.statement) = (yystack_[0].value.compound);
	}
#line 2389 "parser.tab.cpp"
    break;

  case 176: // elsestatement: KW_ELIF LPAR expression RPAR compound elsestatement
#line 1620 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("elsestatement -> KW_ELIF LPAR expression RPAR compound elsestatement");
		(yylhs.value.statement) = helper.MakeIfStatement((yystack_[3].value.expression), (yystack_[1].value.compound), (yystack_[0].value.statement));
	}
#line 2398 "parser.tab.cpp"
    break;

  case 177: // foreach_while: %empty
#line 1628 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("foreach_while -> {empty}");
		(yylhs.value.expression) = 0;
	}
#line 2407 "parser.tab.cpp"
    break;

  case 178: // foreach_while: KW_WHILE expression
#line 1634 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("foreach_while -> KW_WHILE expression");
		(yylhs.value.expression) = (yystack_[0].value.expression);
	}
#line 2416 "parser.tab.cpp"
    break;

  case 179: // foreach_which: %empty
#line 1642 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("foreach_which -> {empty}");
		(yylhs.value.expression) = 0;
	}
#line 2425 "parser.tab.cpp"
    break;

  case 180: // foreach_which: KW_WHICH expression
#line 1648 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("foreach_which -> KW_WHICH expression");
		(yylhs.value.expression) = (yystack_[0].value.expression);
	}
#line 2434 "parser.tab.cpp"
    break;

  case 181: // inclusive_opt: %empty
#line 1656 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("inclusive_opt -> {empty}");
		(yylhs.value.logical) = true;
	}
#line 2443 "parser.tab.cpp"
    break;

  case 182: // inclusive_opt: KW_INCLUSIVE
#line 1662 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("inclusive_opt -> KW_INCLUSIVE");
		(yylhs.value.logical) = true;
	}
#line 2452 "parser.tab.cpp"
    break;

  case 183: // inclusive_opt: KW_EXCLUSIVE
#line 1668 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("inclusive_opt -> KW_EXCLUSIVE");
		(yylhs.value.logical) = false;
	}
#line 2461 "parser.tab.cpp"
    break;

  case 184: // reverse_opt: %empty
#line 1676 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("reverse_opt -> {empty}");
		(yylhs.value.logical) = false;
	}
#line 2470 "parser.tab.cpp"
    break;

  case 185: // reverse_opt: KW_REVERSE
#line 1682 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("reverse_opt -> KW_REVERSE");
		(yylhs.value.logical) = true;
	}
#line 2479 "parser.tab.cpp"
    break;

  case 186: // switchcases: switchcase
#line 1690 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("switchcases -> switchcase");
		(yylhs.value.switchcases) = new switchcases_t;
		(yylhs.value.switchcases)->push_back((yystack_[0].value.switchcase));
	}
#line 2489 "parser.tab.cpp"
    break;

  case 187: // switchcases: switchcases switchcase
#line 1697 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("switchcases -> switchcases switchcase");
		(yylhs.value.switchcases) = (yystack_[1].value.switchcases);
		(yylhs.value.switchcases)->push_back((yystack_[0].value.switchcase));
	}
#line 2499 "parser.tab.cpp"
    break;

  case 188: // @20: %empty
#line 1706 "parser.y"
        {
		if(!helper.mSymTab.EnterBlock()) { helper.PostError("Out of memory."); }
		(yylhs.value.variabledecls) = helper.AddCaseVariables(*(yystack_[2].value.str), (yystack_[1].value.identlist));
	}
#line 2508 "parser.tab.cpp"
    break;

  case 189: // switchcase: KW_CASE SPECIALIDENT identlist COLON @20 compound
#line 1711 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE SPECIALIDENT identlist COLON compound");
		variabledecls_t* vars = (yystack_[1].value.variabledecls);
		(yylhs.value.switchcase) = helper.MakeDataTypeCaseStatement(*(yystack_[4].value.str), vars, (yystack_[0].value.compound));
		helper.mSymTab.LeaveBlock();
		delete vars;
		delete (yystack_[4].value.str);
	}
#line 2521 "parser.tab.cpp"
    break;

  case 190: // @21: %empty
#line 1721 "parser.y"
        {
		if(!helper.mSymTab.EnterBlock()) { helper.PostError("Out of memory."); }
		(yylhs.value.variabledecls) = helper.AddCaseVariables(*(yystack_[4].value.str), *(yystack_[2].value.str), (yystack_[1].value.identlist));
	}
#line 2530 "parser.tab.cpp"
    break;

  case 191: // switchcase: KW_CASE TYPENAME COLONCOLON SPECIALIDENT identlist COLON @21 compound
#line 1726 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE TYPENAME COLONCOLON SPECIALIDENT identlist COLON compound");
		variabledecls_t* vars = (yystack_[1].value.variabledecls);
		(yylhs.value.switchcase) = helper.MakeDataTypeCaseStatement(*(yystack_[6].value.str), *(yystack_[4].value.str), vars, (yystack_[0].value.compound));
		helper.mSymTab.LeaveBlock();
		delete vars;
		delete (yystack_[6].value.str);
		delete (yystack_[4].value.str);
	}
#line 2544 "parser.tab.cpp"
    break;

  case 192: // switchcase: KW_CASE SPECIALIDENT COLON compound
#line 1737 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE SPECIALIDENT COLON compound");
		(yylhs.value.switchcase) = helper.MakeSpecialCaseStatement(*(yystack_[2].value.str), (yystack_[0].value.compound));
		delete (yystack_[2].value.str);
	}
#line 2554 "parser.tab.cpp"
    break;

  case 193: // switchcase: KW_CASE TYPENAME COLONCOLON SPECIALIDENT COLON compound
#line 1744 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("switchcase -> KW_CASE TYPENAME COLONCOLON SPECIALIDENT COLON compound");
		(yylhs.value.switchcase) = helper.MakeSpecialCaseStatement(*(yystack_[4].value.str), *(yystack_[2].value.str), (yystack_[0].value.compound));
		delete (yystack_[4].value.str);
		delete (yystack_[2].value.str);
	}
#line 2565 "parser.tab.cpp"
    break;

  case 194: // default_opt: %empty
#line 1754 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("default_opt -> {empty}");
		(yylhs.value.defaultstatement) = 0;
	}
#line 2574 "parser.tab.cpp"
    break;

  case 195: // default_opt: KW_DEFAULT COLON compound
#line 1760 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("default_opt -> KW_DEFAULT COLON compound");
		(yylhs.value.defaultstatement) = helper.MakeDefaultStatement((yystack_[0].value.compound));
	}
#line 2583 "parser.tab.cpp"
    break;

  case 196: // variabledeclaration: type IDENTIFIER
#line 1768 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("variabledeclaration -> type IDENTIFIER");
		(yylhs.value.variabledeclaration) = new wtast::VariableDeclaration((yystack_[1].value.type));
		const std::string & ident = *(yystack_[0].value.str);
		UniqueId unique_id = helper.CreateUniqueId();
		if(helper.mSymTab.AddVariable((yylhs.value.variabledeclaration)->GetType(), ident, unique_id, helper._GetEHandlerMode(), helper.GetCurrentVariableClass()))
		{
			(yylhs.value.variabledeclaration)->AddFragment(new wtast::VariableDeclFragment((yylhs.value.variabledeclaration), ident, unique_id));
		}
		else
		{
			helper.PostError(std::string("Multiple variable declaration of '") + ident + "'");
		}
		delete (yystack_[0].value.str);
	}
#line 2603 "parser.tab.cpp"
    break;

  case 197: // variabledeclaration: variabledeclaration COMMA IDENTIFIER
#line 1785 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("variabledeclaration -> variabledeclaration COMMA IDENTIFIER");
		(yylhs.value.variabledeclaration) = (yystack_[2].value.variabledeclaration);
		const std::string & ident = *(yystack_[0].value.str);
		UniqueId unique_id = helper.CreateUniqueId();
		if(helper.mSymTab.AddVariable((yylhs.value.variabledeclaration)->GetType(), ident, unique_id, helper._GetEHandlerMode(), helper.GetCurrentVariableClass()))
		{
			(yylhs.value.variabledeclaration)->AddFragment(new wtast::VariableDeclFragment((yylhs.value.variabledeclaration), ident, unique_id));
		}
		else
		{
			helper.PostError(std::string("Multiple variable declaration of '") + ident + "'");
		}
		delete (yystack_[0].value.str);
	}
#line 2623 "parser.tab.cpp"
    break;

  case 198: // variabledeclaration: variabledeclaration SEMICOLON
#line 1802 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("variabledeclaration -> variabledeclaration SEMICOLON");
		(yylhs.value.variabledeclaration) = (yystack_[1].value.variabledeclaration);
		helper.ValidateUninitializedVariable((yylhs.value.variabledeclaration));
	}
#line 2633 "parser.tab.cpp"
    break;

  case 199: // variabledeclaration: variabledeclaration ASSIGN expression SEMICOLON
#line 1809 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("variabledeclaration -> variabledeclaration ASSIGN expression SEMICOLON");
		(yylhs.value.variabledeclaration) = (yystack_[3].value.variabledeclaration);
		if(helper.ValidateInitialValue((yylhs.value.variabledeclaration), (yystack_[1].value.expression)))
		{
			(yylhs.value.variabledeclaration)->SetInitialValue((yystack_[1].value.expression));
		}
	}
#line 2646 "parser.tab.cpp"
    break;

  case 200: // variabledeclarations: variabledeclaration
#line 1821 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("variabledeclarations -> variabledeclaration");
		(yylhs.value.variabledecls) = new variabledecls_t;
		(yylhs.value.variabledecls)->push_back((yystack_[0].value.variabledeclaration));
	}
#line 2656 "parser.tab.cpp"
    break;

  case 201: // variabledeclarations: variabledeclarations variabledeclaration
#line 1828 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("variabledeclarations -> variabledeclarations variabledeclaration");
		(yylhs.value.variabledecls) = (yystack_[1].value.variabledecls);
		(yylhs.value.variabledecls)->push_back((yystack_[0].value.variabledeclaration));
	}
#line 2666 "parser.tab.cpp"
    break;

  case 202: // type: TYPE_CHAR
#line 1837 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_CHAR");
		(yylhs.value.type) = helper.GetStockType(WTT_CHAR);
	}
#line 2675 "parser.tab.cpp"
    break;

  case 203: // type: TYPE_BOOL
#line 1843 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_BOOL");
		(yylhs.value.type) = helper.GetStockType(WTT_BOOL);
	}
#line 2684 "parser.tab.cpp"
    break;

  case 204: // type: TYPE_HANDLE
#line 1849 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_HANDLE");
		(yylhs.value.type) = helper.GetStockType(WTT_HANDLE);
	}
#line 2693 "parser.tab.cpp"
    break;

  case 205: // type: TYPE_STRING
#line 1855 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_STRING");
		(yylhs.value.type) = helper.GetStockType(WTT_STRING);
	}
#line 2702 "parser.tab.cpp"
    break;

  case 206: // type: TYPE_FILE
#line 1861 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_FILE");
		(yylhs.value.type) = helper.GetStockType(WTT_FILE);
	}
#line 2711 "parser.tab.cpp"
    break;

  case 207: // type: TYPE_DIR
#line 1867 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_DIR");
		(yylhs.value.type) = helper.GetStockType(WTT_DIR);
	}
#line 2720 "parser.tab.cpp"
    break;

  case 208: // type: TYPE_I8
#line 1873 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_I8");
		(yylhs.value.type) = helper.GetStockType(WTT_I8);
	}
#line 2729 "parser.tab.cpp"
    break;

  case 209: // type: TYPE_U8
#line 1879 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_U8");
		(yylhs.value.type) = helper.GetStockType(WTT_U8);
	}
#line 2738 "parser.tab.cpp"
    break;

  case 210: // type: TYPE_I16
#line 1885 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_I16");
		(yylhs.value.type) = helper.GetStockType(WTT_I16);
	}
#line 2747 "parser.tab.cpp"
    break;

  case 211: // type: TYPE_U16
#line 1891 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_U16");
		(yylhs.value.type) = helper.GetStockType(WTT_U16);
	}
#line 2756 "parser.tab.cpp"
    break;

  case 212: // type: TYPE_I32
#line 1897 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_I32");
		(yylhs.value.type) = helper.GetStockType(WTT_I32);
	}
#line 2765 "parser.tab.cpp"
    break;

  case 213: // type: TYPE_U32
#line 1903 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_U32");
		(yylhs.value.type) = helper.GetStockType(WTT_U32);
	}
#line 2774 "parser.tab.cpp"
    break;

  case 214: // type: TYPE_I64
#line 1909 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_I64");
		(yylhs.value.type) = helper.GetStockType(WTT_I64);
	}
#line 2783 "parser.tab.cpp"
    break;

  case 215: // type: TYPE_U64
#line 1915 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_U64");
		(yylhs.value.type) = helper.GetStockType(WTT_U64);
	}
#line 2792 "parser.tab.cpp"
    break;

  case 216: // type: TYPE_F32
#line 1921 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_F32");
		(yylhs.value.type) = helper.GetStockType(WTT_F32);
	}
#line 2801 "parser.tab.cpp"
    break;

  case 217: // type: TYPE_F64
#line 1927 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPE_F64");
		(yylhs.value.type) = helper.GetStockType(WTT_F64);
	}
#line 2810 "parser.tab.cpp"
    break;

  case 218: // type: TYPENAME
#line 1933 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> TYPENAME");
		(yylhs.value.type) = helper.ResolveType(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 2820 "parser.tab.cpp"
    break;

  case 219: // type: KW_SEQ LANGLEBRACKET type RANGLEBRACKET
#line 1940 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("type -> KW_SEQ LANGLEBRACKET type RANGLEBRACKET");
		(yylhs.value.type) = helper.GetSeqType((yystack_[1].value.type));
	}
#line 2829 "parser.tab.cpp"
    break;

  case 220: // expression_opt: %empty
#line 1948 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression_opt -> {empty}");
		(yylhs.value.expression) = 0;
	}
#line 2838 "parser.tab.cpp"
    break;

  case 221: // expression_opt: expression
#line 1954 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression_opt -> expression");
		(yylhs.value.expression) = (yystack_[0].value.expression);
	}
#line 2847 "parser.tab.cpp"
    break;

  case 222: // expression: COLONCOLON IDENTIFIER
#line 1962 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> COLONCOLON IDENTIFIER");
		(yylhs.value.expression) = helper.ResolveGlobalFunctionName(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 2857 "parser.tab.cpp"
    break;

  case 223: // expression: COLONCOLON STRINGLIT
#line 1969 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> COLONCOLON STRINGLIT");
		(yylhs.value.expression) = helper.ResolveGlobalFunctionName(helper.ValidateFunctionName(*(yystack_[0].value.str)));
		delete (yystack_[0].value.str);
	}
#line 2867 "parser.tab.cpp"
    break;

  case 224: // expression: expression COMMA expression
#line 1976 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> expression COMMA expression");
		if((yystack_[2].value.expression) && (yystack_[2].value.expression)->IsSimultaneous())
		{
			(yylhs.value.expression) = (yystack_[2].value.expression);
			static_cast<wtast::SimultaneousExpression*>((yylhs.value.expression))->AddExpression(helper.ValidateExpression((yystack_[0].value.expression)));
		}
		else
		{
			(yylhs.value.expression) = new wtast::SimultaneousExpression(helper.ValidateExpression((yystack_[2].value.expression)), helper.ValidateExpression((yystack_[0].value.expression)));
		}
	}
#line 2884 "parser.tab.cpp"
    break;

  case 225: // expression: LPAR expression RPAR
#line 1990 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> LPAR expression RPAR");
		(yylhs.value.expression) = (yystack_[1].value.expression);
	}
#line 2893 "parser.tab.cpp"
    break;

  case 226: // expression: funccallexpr
#line 1996 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> funccallexpr");
		(yylhs.value.expression) = (yystack_[0].value.expression);
	}
#line 2902 "parser.tab.cpp"
    break;

  case 227: // expression: string
#line 2002 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> string");
		(yylhs.value.expression) = new wtast::StringLiteral(helper.GetStockType(WTT_STRING), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 2912 "parser.tab.cpp"
    break;

  case 228: // expression: KW_TRUE
#line 2009 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> KW_TRUE");
		(yylhs.value.expression) = new wtast::BooleanLiteral(helper.GetStockType(WTT_BOOL), WT_TRUE);
	}
#line 2921 "parser.tab.cpp"
    break;

  case 229: // expression: KW_FALSE
#line 2015 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> KW_FALSE");
		(yylhs.value.expression) = new wtast::BooleanLiteral(helper.GetStockType(WTT_BOOL), WT_FALSE);
	}
#line 2930 "parser.tab.cpp"
    break;

  case 230: // expression: CHARLIT
#line 2021 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> CHARLIT");
		(yylhs.value.expression) = new wtast::CharacterLiteral(helper.GetStockType(WTT_CHAR), helper.ParseChar(*(yystack_[0].value.str)));
		delete (yystack_[0].value.str);
	}
#line 2940 "parser.tab.cpp"
    break;

  case 231: // expression: FLOATNUMBER
#line 2028 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> FLOATNUMBER");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_F32), helper.ParseF32(*(yystack_[0].value.str)));
		delete (yystack_[0].value.str);
	}
#line 2950 "parser.tab.cpp"
    break;

  case 232: // expression: DOUBLENUMBER
#line 2035 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> DOUBLENUMBER");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_F64), helper.ParseF64(*(yystack_[0].value.str)));
		delete (yystack_[0].value.str);
	}
#line 2960 "parser.tab.cpp"
    break;

  case 233: // expression: integer8
#line 2042 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> integer8");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_I8), (yystack_[0].value.integer8));
	}
#line 2969 "parser.tab.cpp"
    break;

  case 234: // expression: unsigned8
#line 2048 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> unsigned8");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_U8), (yystack_[0].value.unsigned8));
	}
#line 2978 "parser.tab.cpp"
    break;

  case 235: // expression: integer16
#line 2054 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> integer16");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_I16), (yystack_[0].value.integer16));
	}
#line 2987 "parser.tab.cpp"
    break;

  case 236: // expression: unsigned16
#line 2060 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> unsigned16");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_U16), (yystack_[0].value.unsigned16));
	}
#line 2996 "parser.tab.cpp"
    break;

  case 237: // expression: integer32
#line 2066 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> integer32");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_I32), (yystack_[0].value.integer32));
	}
#line 3005 "parser.tab.cpp"
    break;

  case 238: // expression: unsigned32
#line 2072 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> unsigned32");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_U32), (yystack_[0].value.unsigned32));
	}
#line 3014 "parser.tab.cpp"
    break;

  case 239: // expression: integer64
#line 2078 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> integer64");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_I64), (yystack_[0].value.integer64));
	}
#line 3023 "parser.tab.cpp"
    break;

  case 240: // expression: unsigned64
#line 2084 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> unsigned64");
		(yylhs.value.expression) = new wtast::NumberLiteral(helper.GetStockType(WTT_U64), (yystack_[0].value.unsigned64));
	}
#line 3032 "parser.tab.cpp"
    break;

  case 241: // expression: lvalue
#line 2090 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> lvalue");
		(yylhs.value.expression) = (yystack_[0].value.lvalue);
	}
#line 3041 "parser.tab.cpp"
    break;

  case 242: // expression: KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE RBRACE
#line 2096 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE RBRACE");
		(yylhs.value.expression) = helper.MakeSeqLiteral((yystack_[3].value.type), 0);
	}
#line 3050 "parser.tab.cpp"
    break;

  case 243: // expression: KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE expression RBRACE
#line 2102 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> KW_SEQ LANGLEBRACKET type RANGLEBRACKET LBRACE expression RBRACE");
		(yylhs.value.expression) = helper.MakeSeqLiteral((yystack_[4].value.type), (yystack_[1].value.expression));
	}
#line 3059 "parser.tab.cpp"
    break;

  case 244: // expression: KW_SEQ LBRACE expression RBRACE
#line 2108 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> KW_SEQ LBRACE expression RBRACE");
		(yylhs.value.expression) = helper.MakeSeqLiteral(0, (yystack_[1].value.expression));
	}
#line 3068 "parser.tab.cpp"
    break;

  case 245: // expression: TYPENAME LBRACE RBRACE
#line 2114 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LBRACE RBRACE");
		(yylhs.value.expression) = helper.MakeRecordLiteral(*(yystack_[2].value.str), 0, 0);
		delete (yystack_[2].value.str);
	}
#line 3078 "parser.tab.cpp"
    break;

  case 246: // expression: TYPENAME LBRACE expression RBRACE
#line 2121 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LBRACE expression RBRACE");
		(yylhs.value.expression) = helper.MakeRecordLiteral(*(yystack_[3].value.str), (yystack_[1].value.expression), 0);
		delete (yystack_[3].value.str);
	}
#line 3088 "parser.tab.cpp"
    break;

  case 247: // expression: TYPENAME LBRACE fieldassigns RBRACE
#line 2128 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LBRACE fieldassigns RBRACE");
		(yylhs.value.expression) = helper.MakeRecordLiteral(*(yystack_[3].value.str), 0, (yystack_[1].value.fieldassigns));
		delete (yystack_[3].value.str);
	}
#line 3098 "parser.tab.cpp"
    break;

  case 248: // expression: LPAR expression RPAR LBRACE fieldassigns RBRACE
#line 2135 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> LPAR expression RPAR LBRACE fieldassigns RBRACE");
		(yylhs.value.expression) = helper.MakeRecordUpdate((yystack_[4].value.expression), (yystack_[1].value.fieldassigns));
	}
#line 3107 "parser.tab.cpp"
    break;

  case 249: // expression: SPECIALIDENT
#line 2141 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> SPECIALIDENT");
		(yylhs.value.expression) = helper.MakeSpecialLiteral(*(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3117 "parser.tab.cpp"
    break;

  case 250: // expression: SPECIALIDENT LBRACE expression RBRACE
#line 2148 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> SPECIALIDENT LBRACE expression RBRACE");
		(yylhs.value.expression) = helper.MakeDataTypeLiteral(*(yystack_[3].value.str), (yystack_[1].value.expression));
		delete (yystack_[3].value.str);
	}
#line 3127 "parser.tab.cpp"
    break;

  case 251: // expression: TYPENAME COLONCOLON SPECIALIDENT
#line 2155 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME COLONCOLON SPECIALIDENT");
		(yylhs.value.expression) = helper.MakeSpecialLiteral(*(yystack_[2].value.str), *(yystack_[0].value.str));
		delete (yystack_[2].value.str);
		delete (yystack_[0].value.str);
	}
#line 3138 "parser.tab.cpp"
    break;

  case 252: // expression: TYPENAME COLONCOLON SPECIALIDENT LBRACE expression RBRACE
#line 2163 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME COLONCOLON SPECIALIDENT LBRACE expression RBRACE");
		(yylhs.value.expression) = helper.MakeDataTypeLiteral(*(yystack_[5].value.str), *(yystack_[3].value.str), (yystack_[1].value.expression));
		delete (yystack_[5].value.str);
		delete (yystack_[3].value.str);
	}
#line 3149 "parser.tab.cpp"
    break;

  case 253: // expression: TYPENAME LPAR IDENTIFIER RPAR
#line 2171 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LPAR IDENTIFIER RPAR");
		(yylhs.value.expression) = helper.MakeMakeFunctionPointer(*(yystack_[3].value.str), *(yystack_[1].value.str));
		delete (yystack_[3].value.str);
		delete (yystack_[1].value.str);
	}
#line 3160 "parser.tab.cpp"
    break;

  case 254: // expression: TYPENAME LPAR STRINGLIT RPAR
#line 2179 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("expression -> TYPENAME LPAR STRINGLIT RPAR");
		(yylhs.value.expression) = helper.MakeMakeFunctionPointer(*(yystack_[3].value.str), helper.ValidateFunctionName(*(yystack_[1].value.str)));
		delete (yystack_[3].value.str);
		delete (yystack_[1].value.str);
	}
#line 3171 "parser.tab.cpp"
    break;

  case 255: // funccallexpr: expression LPAR RPAR
#line 2189 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression LPAR RPAR");
		(yylhs.value.expression) = helper.ResolveFunctionCall((yystack_[2].value.expression), 0);
	}
#line 3180 "parser.tab.cpp"
    break;

  case 256: // funccallexpr: expression LPAR expression RPAR
#line 2195 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression LPAR expression RPAR");
		(yylhs.value.expression) = helper.ResolveFunctionCall((yystack_[3].value.expression), (yystack_[1].value.expression));
	}
#line 3189 "parser.tab.cpp"
    break;

  case 257: // funccallexpr: expression OP_LORELSE expression
#line 2201 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LORELSE expression");
		(yylhs.value.expression) = helper.MakeOrElse((yystack_[2].value.expression), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3199 "parser.tab.cpp"
    break;

  case 258: // funccallexpr: expression OP_LANDTHEN expression
#line 2208 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LANDTHEN expression");
		(yylhs.value.expression) = helper.MakeAndThen((yystack_[2].value.expression), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3209 "parser.tab.cpp"
    break;

  case 259: // funccallexpr: expression OP_LEFT03 expression
#line 2215 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT03 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3219 "parser.tab.cpp"
    break;

  case 260: // funccallexpr: expression OP_RIGHT03 expression
#line 2222 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT03 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3229 "parser.tab.cpp"
    break;

  case 261: // funccallexpr: expression OP_LEFT04 expression
#line 2229 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT04 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3239 "parser.tab.cpp"
    break;

  case 262: // funccallexpr: expression OP_RIGHT04 expression
#line 2236 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT04 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3249 "parser.tab.cpp"
    break;

  case 263: // funccallexpr: expression OP_LEFT05 expression
#line 2243 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT05 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3259 "parser.tab.cpp"
    break;

  case 264: // funccallexpr: expression OP_RIGHT05 expression
#line 2250 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT05 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3269 "parser.tab.cpp"
    break;

  case 265: // funccallexpr: expression OP_LEFT06 expression
#line 2257 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT06 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3279 "parser.tab.cpp"
    break;

  case 266: // funccallexpr: expression OP_RIGHT06 expression
#line 2264 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT06 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3289 "parser.tab.cpp"
    break;

  case 267: // funccallexpr: expression OP_LEFT07 expression
#line 2271 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT07 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3299 "parser.tab.cpp"
    break;

  case 268: // funccallexpr: expression OP_RIGHT07 expression
#line 2278 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT07 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3309 "parser.tab.cpp"
    break;

  case 269: // funccallexpr: expression OP_LEFT08 expression
#line 2285 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT08 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3319 "parser.tab.cpp"
    break;

  case 270: // funccallexpr: expression OP_RIGHT08 expression
#line 2292 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT08 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3329 "parser.tab.cpp"
    break;

  case 271: // funccallexpr: expression OP_LEFT09 expression
#line 2299 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT09 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3339 "parser.tab.cpp"
    break;

  case 272: // funccallexpr: expression OP_RIGHT09 expression
#line 2306 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT09 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3349 "parser.tab.cpp"
    break;

  case 273: // funccallexpr: expression OP_LEFT10 expression
#line 2313 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT10 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3359 "parser.tab.cpp"
    break;

  case 274: // funccallexpr: expression OP_RIGHT10 expression
#line 2320 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT10 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3369 "parser.tab.cpp"
    break;

  case 275: // funccallexpr: expression OP_LEFT11 expression
#line 2327 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT11 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3379 "parser.tab.cpp"
    break;

  case 276: // funccallexpr: expression LANGLEBRACKET expression
#line 2334 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression LANGLEBRACKET expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3389 "parser.tab.cpp"
    break;

  case 277: // funccallexpr: expression RANGLEBRACKET expression
#line 2341 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression RANGLEBRACKET expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3399 "parser.tab.cpp"
    break;

  case 278: // funccallexpr: expression OP_RIGHT11 expression
#line 2348 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT11 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3409 "parser.tab.cpp"
    break;

  case 279: // funccallexpr: expression OP_LEFT12 expression
#line 2355 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT12 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3419 "parser.tab.cpp"
    break;

  case 280: // funccallexpr: expression OP_RIGHT12 expression
#line 2362 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT12 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3429 "parser.tab.cpp"
    break;

  case 281: // funccallexpr: expression OP_LEFT13 expression
#line 2369 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT13 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3439 "parser.tab.cpp"
    break;

  case 282: // funccallexpr: expression OP_RIGHT13 expression
#line 2376 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT13 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3449 "parser.tab.cpp"
    break;

  case 283: // funccallexpr: expression OP_LEFT14 expression
#line 2383 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT14 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3459 "parser.tab.cpp"
    break;

  case 284: // funccallexpr: expression OP_RIGHT14 expression
#line 2390 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT14 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3469 "parser.tab.cpp"
    break;

  case 285: // funccallexpr: expression OP_LEFT15 expression
#line 2397 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_LEFT15 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3479 "parser.tab.cpp"
    break;

  case 286: // funccallexpr: expression OP_RIGHT15 expression
#line 2404 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT15 expression");
		(yylhs.value.expression) = helper.ApplyBinaryOperator((yystack_[2].value.expression), *(yystack_[1].value.str), (yystack_[0].value.expression));
		delete (yystack_[1].value.str);
	}
#line 3489 "parser.tab.cpp"
    break;

  case 287: // funccallexpr: expression OP_RIGHT03
#line 2411 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT03");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3499 "parser.tab.cpp"
    break;

  case 288: // funccallexpr: OP_LEFT03 expression
#line 2418 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT03 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3509 "parser.tab.cpp"
    break;

  case 289: // funccallexpr: expression OP_RIGHT04
#line 2425 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT04");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3519 "parser.tab.cpp"
    break;

  case 290: // funccallexpr: OP_LEFT04 expression
#line 2432 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT04 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3529 "parser.tab.cpp"
    break;

  case 291: // funccallexpr: expression OP_RIGHT05
#line 2439 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT05");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3539 "parser.tab.cpp"
    break;

  case 292: // funccallexpr: OP_LEFT05 expression
#line 2446 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT05 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3549 "parser.tab.cpp"
    break;

  case 293: // funccallexpr: expression OP_RIGHT06
#line 2453 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT06");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3559 "parser.tab.cpp"
    break;

  case 294: // funccallexpr: OP_LEFT06 expression
#line 2460 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT06 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3569 "parser.tab.cpp"
    break;

  case 295: // funccallexpr: expression OP_RIGHT07
#line 2467 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT07");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3579 "parser.tab.cpp"
    break;

  case 296: // funccallexpr: OP_LEFT07 expression
#line 2474 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT07 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3589 "parser.tab.cpp"
    break;

  case 297: // funccallexpr: expression OP_RIGHT08
#line 2481 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT08");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3599 "parser.tab.cpp"
    break;

  case 298: // funccallexpr: OP_LEFT08 expression
#line 2488 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT08 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3609 "parser.tab.cpp"
    break;

  case 299: // funccallexpr: expression OP_RIGHT09
#line 2495 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT09");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3619 "parser.tab.cpp"
    break;

  case 300: // funccallexpr: OP_LEFT09 expression
#line 2502 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT09 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3629 "parser.tab.cpp"
    break;

  case 301: // funccallexpr: expression OP_RIGHT10
#line 2509 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT10");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3639 "parser.tab.cpp"
    break;

  case 302: // funccallexpr: OP_LEFT10 expression
#line 2516 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT10 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3649 "parser.tab.cpp"
    break;

  case 303: // funccallexpr: expression OP_RIGHT11
#line 2523 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT11");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3659 "parser.tab.cpp"
    break;

  case 304: // funccallexpr: OP_LEFT11 expression
#line 2530 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT11 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3669 "parser.tab.cpp"
    break;

  case 305: // funccallexpr: LANGLEBRACKET expression
#line 2537 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> LANGLEBRACKET expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3679 "parser.tab.cpp"
    break;

  case 306: // funccallexpr: RANGLEBRACKET expression
#line 2544 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> RANGLEBRACKET expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3689 "parser.tab.cpp"
    break;

  case 307: // funccallexpr: expression OP_RIGHT12
#line 2551 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT12");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3699 "parser.tab.cpp"
    break;

  case 308: // funccallexpr: OP_LEFT12 expression
#line 2558 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT12 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3709 "parser.tab.cpp"
    break;

  case 309: // funccallexpr: expression OP_RIGHT13
#line 2565 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT13");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3719 "parser.tab.cpp"
    break;

  case 310: // funccallexpr: OP_LEFT13 expression
#line 2572 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT13 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3729 "parser.tab.cpp"
    break;

  case 311: // funccallexpr: expression OP_RIGHT14
#line 2579 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT14");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3739 "parser.tab.cpp"
    break;

  case 312: // funccallexpr: OP_LEFT14 expression
#line 2586 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT14 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3749 "parser.tab.cpp"
    break;

  case 313: // funccallexpr: expression OP_RIGHT15
#line 2593 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> expression OP_RIGHT15");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[1].value.expression), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3759 "parser.tab.cpp"
    break;

  case 314: // funccallexpr: OP_LEFT15 expression
#line 2600 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("funccallexpr -> OP_LEFT15 expression");
		(yylhs.value.expression) = helper.ApplyUnaryOperator((yystack_[0].value.expression), *(yystack_[1].value.str));
		delete (yystack_[1].value.str);
	}
#line 3769 "parser.tab.cpp"
    break;

  case 315: // lvalue: IDENTIFIER
#line 2609 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveVariableAccess(*(yystack_[0].value.str), SymTab::UnnamedFrame);
		delete (yystack_[0].value.str);
	}
#line 3779 "parser.tab.cpp"
    break;

  case 316: // lvalue: IDENTIFIER COLONCOLON IDENTIFIER
#line 2616 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> IDENTIFIER COLONCOLON IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveVariableAccess(*(yystack_[0].value.str), *(yystack_[2].value.str));
		delete (yystack_[2].value.str);
		delete (yystack_[0].value.str);
	}
#line 3790 "parser.tab.cpp"
    break;

  case 317: // lvalue: KW_GLOBAL COLONCOLON IDENTIFIER
#line 2624 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> KW_GLOBAL COLONCOLON IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveVariableAccess(*(yystack_[0].value.str), helper.GlobalBlockName);
		delete (yystack_[0].value.str);
	}
#line 3800 "parser.tab.cpp"
    break;

  case 318: // lvalue: KW_MAIN COLONCOLON IDENTIFIER
#line 2631 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> KW_MAIN COLONCOLON IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveVariableAccess(*(yystack_[0].value.str), helper.MainBlockName);
		delete (yystack_[0].value.str);
	}
#line 3810 "parser.tab.cpp"
    break;

  case 319: // lvalue: KW_CTOR COLONCOLON IDENTIFIER
#line 2638 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> KW_CTOR COLONCOLON IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveVariableAccess(*(yystack_[0].value.str), helper.CtorBlockName);
		delete (yystack_[0].value.str);
	}
#line 3820 "parser.tab.cpp"
    break;

  case 320: // lvalue: KW_DTOR COLONCOLON IDENTIFIER
#line 2645 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> KW_DTOR COLONCOLON IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveVariableAccess(*(yystack_[0].value.str), helper.DtorBlockName);
		delete (yystack_[0].value.str);
	}
#line 3830 "parser.tab.cpp"
    break;

  case 321: // lvalue: lvalue LBRACKET expression RBRACKET
#line 2652 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> lvalue LBRACKET expression RBRACKET");
		if((yystack_[3].value.lvalue) && (yystack_[1].value.expression))
		{
			wtast::TypeInfo* info = (yystack_[3].value.lvalue)->GetType();
			wtast::TypeInfo* eti  = (yystack_[1].value.expression)->GetType();

			if(helper.CanBeIndexed(info, eti))
			{
				wtast::TypeInfo* resultType = 0;

				if(WTT_STRING==(static_cast<wtast::Type*>(info)->GetTypeId() & ~WTTF_MUTABLE))
				{
					resultType = helper.GetStockType(WTT_CHAR);
				}
				else
				{
					resultType = static_cast<wtast::SeqType*>(info)->GetElementType();
				}

				(yylhs.value.lvalue) = new wtast::ElementAccess((yystack_[3].value.lvalue), (yystack_[1].value.expression), resultType);
			}
			else
			{
				helper.PostError(std::string("Cannot index '") + (yystack_[3].value.lvalue)->GetType()->GetName() + "' type.");
				(yylhs.value.lvalue) = 0;
			}
		}
		else
		{
			(yylhs.value.lvalue) = 0;
		}
	}
#line 3868 "parser.tab.cpp"
    break;

  case 322: // lvalue: lvalue DOT IDENTIFIER
#line 2687 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> lvalue DOT IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveMemberAccess((yystack_[2].value.lvalue), *(yystack_[0].value.str));
		delete (yystack_[0].value.str);
	}
#line 3878 "parser.tab.cpp"
    break;

  case 323: // lvalue: KW_OLD IDENTIFIER
#line 2694 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("lvalue -> KW_OLD IDENTIFIER");
		(yylhs.value.lvalue) = helper.ResolveVariableAccess(std::string("old ") + *(yystack_[0].value.str), SymTab::UnnamedFrame);
		delete (yystack_[0].value.str);
	}
#line 3888 "parser.tab.cpp"
    break;

  case 324: // assignment_opt: %empty
#line 2703 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("assignment_opt -> {empty}");
		(yylhs.value.assignment) = 0;
	}
#line 3897 "parser.tab.cpp"
    break;

  case 325: // assignment_opt: assignment
#line 2709 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("assignment_opt -> assignment");
		(yylhs.value.assignment) = (yystack_[0].value.assignment);
	}
#line 3906 "parser.tab.cpp"
    break;

  case 326: // assignment: assignment_builder
#line 2717 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("assignment -> assignment_builder");
		helper.ValidateAssignment((yystack_[0].value.assignment));
		(yylhs.value.assignment) = (yystack_[0].value.assignment);
	}
#line 3916 "parser.tab.cpp"
    break;

  case 327: // assignment_builder: lvalue ASSIGN expression
#line 2726 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("assignment_builder -> lvalue ASSIGN expression");
		(yylhs.value.assignment) = new wtast::Assignment((yystack_[2].value.lvalue), (yystack_[0].value.expression));
	}
#line 3925 "parser.tab.cpp"
    break;

  case 328: // assignment_builder: lvalue COMMA assignment_builder
#line 2732 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("assignment_builder -> lvalue COMMA assignment_builder");
		(yylhs.value.assignment) = (yystack_[0].value.assignment);
		(yylhs.value.assignment)->AddFront((yystack_[2].value.lvalue));
	}
#line 3935 "parser.tab.cpp"
    break;

  case 329: // fieldassigns: fieldassign
#line 2741 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("fieldassigns -> fieldassign");
		(yylhs.value.fieldassigns) = new fieldassigns_t;
		(yylhs.value.fieldassigns)->push_back((yystack_[0].value.fieldassign));
	}
#line 3945 "parser.tab.cpp"
    break;

  case 330: // fieldassigns: fieldassigns fieldassign
#line 2748 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("fieldassigns -> fieldassigns fieldassign");
		(yylhs.value.fieldassigns) = (yystack_[1].value.fieldassigns);
		(yylhs.value.fieldassigns)->push_back((yystack_[0].value.fieldassign));
	}
#line 3955 "parser.tab.cpp"
    break;

  case 331: // fieldassign: DOT IDENTIFIER ASSIGN expression SEMICOLON
#line 2757 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("fieldassign -> DOT IDENTIFIER ASSIGN expression SEMICOLON");
		(yylhs.value.fieldassign) = new wtast::FieldAssign((yystack_[1].value.expression));
		(yylhs.value.fieldassign)->AddFieldNameFront(*(yystack_[3].value.str));
		delete (yystack_[3].value.str);
	}
#line 3966 "parser.tab.cpp"
    break;

  case 332: // fieldassign: DOT IDENTIFIER COMMA fieldassign
#line 2765 "parser.y"
        {
		helper.mRuleDebugger.PrintRule("fieldassign -> DOT IDENTIFIER COMMA fieldassign");
		(yylhs.value.fieldassign) = (yystack_[0].value.fieldassign);
		(yylhs.value.fieldassign)->AddFieldNameFront(*(yystack_[2].value.str));
		delete (yystack_[2].value.str);
	}
#line 3977 "parser.tab.cpp"
    break;


#line 3981 "parser.tab.cpp"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  WTParser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
  WTParser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0





  const short WTParser::yypact_ninf_ = -569;

  const signed char WTParser::yytable_ninf_ = -1;

  const short
  WTParser::yypact_[] =
  {
     301,  -569,   187,   -43,  -569,  -569,   -48,   -22,    65,    85,
      17,   181,   373,   373,   373,   373,   373,   373,   373,   160,
    4745,  -569,  -569,  -569,  -569,   248,    -1,    83,  -569,  -569,
    -569,  -569,  -569,  -569,   143,   145,   373,   126,  -569,   190,
     190,  -569,  -569,  -569,  -569,   345,   463,  -569,  -569,  -569,
    -569,  -569,  -569,   198,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,   121,  -569,  -569,  -569,  1002,   230,  -569,  -569,   221,
     253,   401,  1002,  -569,  -569,  -569,   249,   249,    33,   190,
     824,  -569,  -569,  1002,  -569,  -569,  -569,   255,   265,   287,
     289,   373,   277,  1002,   247,  1002,  -569,  1002,  -569,  -569,
    -569,  -569,  -569,  -569,  -569,  -569,   249,   249,  -569,  -569,
     -33,  -569,  -569,   290,   292,  1108,   280,   298,   300,   302,
     -56,   299,   315,   316,   319,   328,   278,   347,   189,  1534,
    -569,  -569,    55,   134,   296,  -569,  -569,  -569,  -569,  -569,
    -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,  -569,  -569,  -569,  -569,  1534,  1534,  1534,  1534,  1534,
    1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,  1534,
    -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,
     824,  -569,    73,   281,  4461,   355,    78,   356,  -569,    73,
    3397,  2639,  2754,  2869,  -569,  -569,  -569,  -569,  -569,   346,
     375,   274,  -569,  -569,  -569,  -569,  -569,  1534,  1002,   334,
     335,   -32,  -569,   362,   134,    88,  -569,    77,   348,   349,
     360,   361,   363,   397,  1534,   -15,   377,  1534,  1534,  -569,
    1534,  -569,  -569,  3501,   824,   378,  -569,   379,   210,   966,
    1534,  4580,  4398,  3557,  3675,   -63,  3795,  2369,   135,   291,
     291,   291,   -54,   239,   -23,   -62,   432,  -569,  -569,  1534,
     380,  -569,  1250,  1534,  1534,  1534,  1676,  1534,  1534,  1818,
    1534,  1960,  1534,  2102,  1534,  2244,  1534,  2386,  1534,  2528,
    1534,  2643,  1534,  1534,  1534,  2758,  1534,  2873,  1534,  2988,
    1534,  3103,  1534,  3218,  -569,   384,  1534,  1534,   -15,  -569,
    -569,    73,   385,   386,   408,   420,   257,   387,   388,    99,
     389,  -569,  -569,   406,  -569,  -569,  1534,   410,   190,  -569,
    3532,   333,   413,   414,  1002,  -569,  -569,  -569,  -569,  -569,
     416,  3621,    78,   424,  -569,   448,  3652,  3741,  3772,   419,
     506,  -569,   824,   421,   423,   427,   409,  -569,  3861,    80,
    -569,  3892,   430,   478,  -569,  3217,  -569,  -569,  3981,  4491,
    4580,  4580,  4580,  4398,  4398,  4398,  3557,  3557,  3675,  3675,
     -63,   -63,  3795,  3795,  2369,  2369,   135,   135,   291,   291,
     291,   291,   -54,   -54,   239,   239,   -23,   -23,   -62,   -62,
    -569,  4461,  4012,  -569,   440,   451,   436,   439,   445,   446,
     447,  1002,   467,   441,   468,  -569,  4101,   461,  -569,  -569,
     481,   459,   493,   411,  1534,   -56,  1534,  1534,   -56,   494,
    -569,   492,  -569,   665,  1534,  -569,  -569,     2,  -569,  -569,
    -569,  -569,   -47,  -569,   484,  -569,  -569,  -569,  -569,  -569,
     -49,   -39,   249,   249,   249,   499,  -569,  -569,  -569,  -569,
    -569,   437,   495,  1392,  -569,  -569,   481,  4132,   267,   501,
    4461,  3412,  -569,  -569,   496,   137,  -569,  4221,  1534,   492,
     497,   498,   -56,  -569,  3414,  -569,  -569,  -569,  -569,   504,
     509,   510,  -569,   206,   -70,   485,  -569,  -569,  4252,   511,
     -56,   507,  -569,   -15,  1534,   535,   521,  -569,  -569,  3313,
    -569,   -56,   -56,  -569,  -569,  -569,   543,  3507,  3524,  -569,
    -569,  -569,   -53,  1002,  -569,   246,   519,  -569,   -59,  -569,
    -569,    70,  -569,  -569,   512,  -569,  -569,  -569,  1534,   513,
    4461,  -569,   544,   215,   275,  -569,  -569,  -569,   432,   522,
    -569,  -569,  -569,   524,  -569,  -569,  -569,  -569,  -569,  1002,
    -569,   -70,   461,  4341,   -56,   308,  1534,   590,   523,   -45,
     572,  -569,   562,  -569,  -569,  -569,  -569,  -569,   576,   -56,
    -569,  -569,  -569,   535,  4461,  1534,   569,   550,   -56,   -55,
     -56,  -569,  -569,   267,   544,  4461,   -56,   -41,  -569,  -569,
    -569,  1534,  -569,   590,  -569,   -56,     4,   -56,  4372,   573,
    -569,  -569,  -569,  -569,   -56,   -56,  -569,  -569
  };

  const short
  WTParser::yydefact_[] =
  {
       0,     2,     0,    86,    33,    35,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     4,     6,     7,    37,     0,     0,   136,    26,    27,
      28,    29,    30,    25,     0,     0,    23,     0,    31,     0,
       0,    14,    10,    12,     8,     0,     0,    16,    17,    18,
      19,    20,    21,     0,     1,     3,     5,    39,   202,   203,
     204,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,     0,   205,   206,   207,     0,   134,   218,   143,     0,
     135,     0,     0,   137,   138,    24,     0,     0,     0,     0,
     152,    34,    36,     0,    50,    50,    50,     0,     0,     0,
       0,     0,    40,     0,     0,     0,   132,     0,   144,   147,
     110,   111,   108,   109,    88,    89,     0,     0,    87,    32,
       0,   228,   229,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     148,   230,   315,   218,   249,   231,   232,    94,    98,   102,
     106,   114,   118,   122,    95,    99,   103,   107,   115,   119,
     123,    92,    96,   100,   104,   112,   116,   120,    93,    97,
     101,   105,   113,   117,   121,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     227,   233,   234,   235,   236,   237,   238,   239,   240,   156,
      84,   153,   155,     0,     0,   226,   241,     0,   326,   200,
       0,     0,     0,     0,   139,   140,   141,   142,    22,     0,
      42,     0,   133,   145,   146,    90,    91,     0,     0,     0,
       0,     0,   159,   315,     0,     0,   226,   241,     0,     0,
       0,     0,     0,     0,     0,   324,     0,     0,     0,   323,
       0,   223,   222,     0,   152,     0,   150,     0,     0,     0,
       0,   288,   290,   292,   294,   296,   298,   300,   302,   304,
     305,   306,   308,   310,   312,   314,   124,   154,   198,     0,
       0,   196,     0,     0,     0,     0,   287,     0,     0,   289,
       0,   291,     0,   293,     0,   295,     0,   297,     0,   299,
       0,   301,     0,     0,     0,   303,     0,   307,     0,   309,
       0,   311,     0,   313,   158,     0,     0,     0,     0,   157,
      15,   201,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    11,    51,     0,    13,     9,     0,     0,     0,   219,
       0,     0,     0,     0,     0,   160,   318,   319,   320,   317,
       0,     0,     0,     0,   325,     0,     0,     0,     0,   225,
       0,   316,   152,   251,     0,     0,     0,   245,     0,     0,
     329,     0,     0,   129,   125,     0,   197,   255,     0,   224,
     259,   257,   260,   261,   258,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     322,   327,     0,   328,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    52,     0,    48,    38,   244,
     219,     0,     0,     0,     0,     0,   220,     0,     0,     0,
     172,     0,   149,     0,     0,   254,   253,     0,   246,   247,
     330,   250,     0,   130,     0,   199,   256,   321,    59,    68,
       0,     0,     0,     0,     0,     0,    64,    53,    66,    41,
      46,    49,     0,     0,   161,   162,     0,     0,   174,     0,
     221,   168,   163,   171,     0,     0,   151,     0,     0,     0,
       0,     0,     0,    85,     0,    58,    68,    56,    68,     0,
       0,     0,    63,     0,     0,     0,    43,   242,     0,     0,
       0,     0,   170,   324,     0,   184,     0,   248,   252,     0,
     332,     0,     0,   131,    54,    69,     0,     0,     0,    61,
      60,    62,     0,    77,    78,     0,     0,    75,     0,    73,
      74,     0,    71,    47,     0,   243,   164,   175,     0,     0,
     166,   185,   177,     0,   194,   186,   331,   126,   127,     0,
      57,    55,    77,     0,    82,    65,    76,    79,    81,     0,
      67,     0,    48,     0,     0,   181,     0,   179,     0,     0,
       0,   187,     0,   128,    70,    80,    83,    72,     0,     0,
     165,   182,   183,   184,   178,     0,     0,     0,     0,     0,
       0,   173,    44,   174,   177,   180,     0,     0,   192,   188,
     195,     0,   176,   179,   169,     0,     0,     0,     0,     0,
     193,   190,   189,    45,     0,     0,   167,   191
  };

  const short
  WTParser::yypgoto_[] =
  {
    -569,  -569,  -569,   632,  -569,  -569,  -569,  -569,  -569,   101,
    -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,  -568,    82,   263,  -569,  -569,  -569,  -283,  -569,  -569,
      87,  -569,   124,   127,  -569,   -35,  -569,  -569,  -569,  -569,
    -569,  -569,  -569,   -83,  -569,  -569,  -569,  -569,   106,  -569,
    -569,   585,     1,  -569,  -569,  -569,  -128,  -569,  -569,  -242,
    -162,  -569,  -569,  -569,    84,    64,    81,  -569,    97,  -569,
     146,  -569,  -569,  -569,   -85,  -569,   -25,  -569,  -116,   -38,
     -46,   178,  -239,   383,   261,  -362
  };

  const short
  WTParser::yydefgoto_[] =
  {
       0,    19,    20,    21,    96,    94,    95,    93,    22,   190,
      36,    23,    89,    39,    40,    57,   102,   220,   338,   544,
     611,   471,   472,   211,   332,   503,   504,   494,   525,   541,
     542,   535,   536,   537,   538,    91,   276,    38,    88,   191,
     192,   193,   194,   195,   196,   197,   198,   373,   374,   454,
     492,    78,   333,    25,    26,    27,   199,   254,   362,   200,
     201,   575,   515,   484,   512,   577,   596,   593,   552,   554,
     555,   617,   625,   582,   202,   210,   203,   479,   204,   236,
     237,   353,   207,   208,   369,   370
  };

  const short
  WTParser::yytable_[] =
  {
      79,    24,   243,   114,   115,    92,   354,   450,   209,   235,
     568,   599,   360,   282,   282,   609,   126,   127,   128,   129,
     495,    24,   282,   253,   140,   598,   539,   490,   540,   615,
     497,   496,    41,   225,   226,    37,   116,   117,   277,   616,
     242,   498,    45,   562,   206,   534,   136,   227,   227,   491,
     104,   470,   205,   282,   119,   470,    79,   109,    42,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   621,   569,    80,   488,   221,   505,
     223,   233,   224,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   313,    35,   307,   308,   309,   310,   311,   312,
     313,   340,   118,    47,    48,    49,    50,    51,    52,    53,
     443,   228,   344,   450,     2,   321,   255,   520,   351,    86,
      87,   356,   357,    81,   358,   256,   489,    85,   505,   311,
     312,   313,   278,   368,   371,    43,    98,   100,   279,   315,
     315,   570,   366,   316,   206,   317,   317,   345,    10,    11,
      54,   449,   205,   375,   282,    44,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   277,   352,
     411,   412,   218,   341,   571,   257,    46,   280,   206,   366,
     258,   282,   318,   527,   259,   528,   205,    82,   517,    83,
     426,    84,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      90,   532,   352,   101,   354,   103,    28,    29,    30,    31,
      32,   277,    33,    34,   251,   252,    75,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     105,     1,   533,   428,   534,   364,   365,   478,   510,   511,
     482,   532,   578,   579,   206,   282,   206,   106,   477,   433,
     480,   481,   205,   107,   205,    76,     2,   565,   487,   219,
     423,   214,     3,     4,     5,     6,     7,     8,     9,   553,
     580,   215,   533,   222,   534,    77,    28,    29,    30,    31,
      32,   238,    33,   418,   110,   591,   592,   508,   212,   213,
      10,    11,   111,   216,   523,   217,   229,   282,   230,   239,
     112,   240,   519,   241,   249,   244,   260,   281,   113,   499,
     500,   501,   547,    12,    13,    14,    15,    16,    17,    18,
     419,   245,   246,   557,   558,   247,   465,   206,   550,   309,
     310,   311,   312,   313,   248,   205,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,   250,   314,   319,   336,   420,   337,   339,
     342,   343,   573,   255,    28,    29,    30,    31,    32,    75,
      33,    97,   350,   256,   346,   347,   590,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   348,   349,   372,   416,
     594,   603,    28,    29,    30,    31,    32,   352,    33,   526,
     608,   417,   610,   355,   361,   425,   376,   363,   614,   605,
     410,   414,   415,   421,   422,   424,   427,   620,   430,   622,
     431,   432,   434,   436,   437,   618,   626,   627,    77,   441,
     445,   444,   526,   526,   446,   447,   452,   453,   564,   458,
     467,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,   120,    72,    73,    74,   474,   121,
     122,   459,   460,   123,   124,   461,   125,   126,   127,   128,
     129,   462,   463,   464,   586,   130,   131,   466,   468,   132,
     133,   134,    28,    29,    30,    31,    32,   470,    33,    99,
     135,   473,   475,   483,   366,   493,   476,   136,   502,   137,
     513,   505,   506,   529,   521,   522,   516,   138,   530,   531,
     546,   543,   139,   548,   551,   553,   140,   442,   567,   576,
     574,   584,   572,   585,   597,    28,    29,    30,    31,    32,
     141,    33,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   110,   151,   152,   153,   154,   155,   156,   157,   111,
     158,   159,   160,   161,   162,   163,   164,   112,   165,   166,
     167,   168,   169,   170,   171,   113,   172,   173,   174,   559,
     595,   175,   600,   601,   176,   602,   606,   177,   607,   178,
     624,   179,    56,   180,   588,   181,   563,   182,   587,   183,
     184,   185,   566,   186,   583,   187,   108,   188,   613,   189,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,   120,    72,    73,    74,   612,   121,   122,
     604,   549,   123,   124,   619,   125,   126,   127,   128,   129,
     581,   413,   485,     0,   130,   131,     0,     0,   132,   133,
     134,     0,     0,     0,     0,     0,     0,     0,     0,   135,
       0,     0,     0,     0,     0,     0,   136,     0,   137,     0,
       0,     0,     0,     0,     0,     0,   138,     0,     0,     0,
       0,   139,     0,     0,     0,   140,   486,     0,     0,     0,
       0,     0,     0,     0,    28,    29,    30,    31,    32,   141,
      33,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     110,   151,   152,   153,   154,   155,   156,   157,   111,   158,
     159,   160,   161,   162,   163,   164,   112,   165,   166,   167,
     168,   169,   170,   171,   113,   172,   173,   174,     0,     0,
     175,     0,     0,   176,     0,     0,   177,     0,   178,     0,
     179,     0,   180,     0,   181,     0,   182,     0,   183,   184,
     185,     0,   186,     0,   187,     0,   188,     0,   189,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,   120,    72,    73,    74,     0,   121,   122,     0,
       0,   123,   124,     0,   125,   126,   127,   128,   129,     0,
       0,     0,     0,   130,   131,     0,     0,   132,   133,   134,
       0,     0,     0,     0,     0,     0,     0,     0,   135,     0,
       0,     0,     0,     0,     0,   136,     0,   137,     0,     0,
       0,     0,     0,     0,     0,   138,     0,     0,     0,     0,
     139,     0,     0,     0,   140,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,    30,    31,    32,   141,    33,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   110,
     151,   152,   153,   154,   155,   156,   157,   111,   158,   159,
     160,   161,   162,   163,   164,   112,   165,   166,   167,   168,
     169,   170,   171,   113,   172,   173,   174,     0,     0,   175,
       0,     0,   176,     0,     0,   177,     0,   178,     0,   179,
       0,   180,     0,   181,     0,   182,     0,   183,   184,   185,
       0,   186,     0,   187,   231,   188,     0,   189,     0,   121,
     122,     0,     0,     0,     0,     0,     0,   126,   127,   128,
     129,     0,     0,     0,     0,     0,     0,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,     0,     0,     0,   136,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   138,   366,     0,
       0,     0,   139,     0,     0,     0,     0,   367,     0,     0,
       0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
     141,    33,   233,   234,   144,   145,   146,   147,   148,   149,
     150,   110,   151,   152,   153,   154,   155,   156,   157,   111,
     158,   159,   160,   161,   162,   163,   164,   112,   165,   166,
     167,   168,   169,   170,   171,   113,   172,   173,   174,    77,
       0,   175,     0,     0,   176,     0,     0,   177,     0,   178,
       0,   179,     0,   180,     0,   181,     0,   182,     0,   183,
     184,   185,     0,   186,     0,   187,   231,   188,     0,   189,
       0,   121,   122,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   136,
       0,     0,     0,     0,     0,     0,     0,   232,     0,   138,
       0,     0,     0,     0,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
      31,    32,   141,    33,   233,   234,   144,   145,   146,   147,
     148,   149,   150,   110,   151,   152,   153,   154,   155,   156,
     157,   111,   158,   159,   160,   161,   162,   163,   164,   112,
     165,   166,   167,   168,   169,   170,   171,   113,   172,   173,
     174,     0,     0,   175,     0,     0,   176,     0,     0,   177,
       0,   178,     0,   179,     0,   180,     0,   181,     0,   182,
       0,   183,   184,   185,     0,   186,     0,   187,   231,   188,
       0,   189,     0,   121,   122,     0,     0,     0,     0,     0,
       0,   126,   127,   128,   129,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   138,     0,     0,     0,     0,   139,   377,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    28,
      29,    30,    31,    32,   141,    33,   233,   234,   144,   145,
     146,   147,   148,   149,   150,   110,   151,   152,   153,   154,
     155,   156,   157,   111,   158,   159,   160,   161,   162,   163,
     164,   112,   165,   166,   167,   168,   169,   170,   171,   113,
     172,   173,   174,     0,     0,   175,     0,     0,   176,     0,
       0,   177,     0,   178,     0,   179,     0,   180,     0,   181,
       0,   182,     0,   183,   184,   185,     0,   186,     0,   187,
     231,   188,     0,   189,     0,   121,   122,     0,     0,     0,
       0,     0,     0,   126,   127,   128,   129,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   136,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   138,     0,     0,     0,     0,   139,     0,
       0,     0,     0,   507,     0,     0,     0,     0,     0,     0,
       0,    28,    29,    30,    31,    32,   141,    33,   233,   234,
     144,   145,   146,   147,   148,   149,   150,   110,   151,   152,
     153,   154,   155,   156,   157,   111,   158,   159,   160,   161,
     162,   163,   164,   112,   165,   166,   167,   168,   169,   170,
     171,   113,   172,   173,   174,     0,     0,   175,     0,     0,
     176,     0,     0,   177,     0,   178,     0,   179,     0,   180,
       0,   181,     0,   182,     0,   183,   184,   185,     0,   186,
       0,   187,   231,   188,     0,   189,     0,   121,   122,     0,
       0,     0,     0,     0,     0,   126,   127,   128,   129,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   136,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   138,     0,     0,     0,     0,
     139,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,    30,    31,    32,   141,    33,
     233,   234,   144,   145,   146,   147,   148,   149,   150,   110,
     151,   152,   153,   154,   155,   156,   157,   111,   158,   159,
     160,   161,   162,   163,   164,   112,   165,   166,   167,   168,
     169,   170,   171,   113,   172,   173,   174,     0,     0,   175,
       0,     0,   176,     0,     0,   177,     0,   178,     0,   179,
       0,   180,     0,   181,     0,   182,     0,   183,   184,   185,
       0,   186,     0,   187,   231,   188,     0,   189,     0,   121,
     122,     0,     0,     0,     0,     0,     0,   126,   127,   128,
     129,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   136,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   138,     0,     0,
       0,     0,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
     141,    33,   233,   234,   144,   145,   146,   147,   148,   149,
     150,   110,   151,   152,   153,   154,   155,   156,   157,   111,
     158,   159,   160,   161,   162,   163,   164,   112,   165,   166,
     167,   168,   169,   170,   171,   113,   172,   173,   174,     0,
       0,     0,     0,     0,   176,     0,     0,   177,     0,   178,
       0,   179,     0,   180,     0,   181,     0,   182,     0,   183,
     184,   185,     0,   186,     0,   187,   231,   188,     0,   189,
       0,   121,   122,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   136,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   138,
       0,     0,     0,     0,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
      31,    32,   141,    33,   233,   234,   144,   145,   146,   147,
     148,   149,   150,   110,   151,   152,   153,   154,   155,   156,
     157,   111,   158,   159,   160,   161,   162,   163,   164,   112,
     165,   166,   167,   168,   169,   170,   171,   113,   172,   173,
     174,     0,     0,     0,     0,     0,     0,     0,     0,   177,
       0,   178,     0,   179,     0,   180,     0,   181,     0,   182,
       0,   183,   184,   185,     0,   186,     0,   187,   231,   188,
       0,   189,     0,   121,   122,     0,     0,     0,     0,     0,
       0,   126,   127,   128,   129,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   138,     0,     0,     0,     0,   139,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    28,
      29,    30,    31,    32,   141,    33,   233,   234,   144,   145,
     146,   147,   148,   149,   150,   110,   151,   152,   153,   154,
     155,   156,   157,   111,   158,   159,   160,   161,   162,   163,
     164,   112,   165,   166,   167,   168,   169,   170,   171,   113,
     172,   173,   174,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   178,     0,   179,     0,   180,     0,   181,
       0,   182,     0,   183,   184,   185,     0,   186,     0,   187,
     231,   188,     0,   189,     0,   121,   122,     0,     0,     0,
       0,     0,     0,   126,   127,   128,   129,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   136,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   138,     0,     0,     0,     0,   139,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,    29,    30,    31,    32,   141,    33,   233,   234,
     144,   145,   146,   147,   148,   149,   150,   110,   151,   152,
     153,   154,   155,   156,   157,   111,   158,   159,   160,   161,
     162,   163,   164,   112,   165,   166,   167,   168,   169,   170,
     171,   113,   172,   173,   174,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   179,     0,   180,
       0,   181,     0,   182,     0,   183,   184,   185,     0,   186,
       0,   187,   231,   188,     0,   189,     0,   121,   122,     0,
       0,     0,     0,     0,     0,   126,   127,   128,   129,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   136,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   138,     0,     0,     0,     0,
     139,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,    30,    31,    32,   141,    33,
     233,   234,   144,   145,   146,   147,   148,   149,   150,   110,
     151,   152,   153,   154,   155,   156,   157,   111,   158,   159,
     160,   161,   162,   163,   164,   112,   165,   166,   167,   168,
     169,   170,   171,   113,   172,   173,   174,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   180,     0,   181,     0,   182,     0,   183,   184,   185,
       0,   186,     0,   187,   231,   188,     0,   189,     0,   121,
     122,     0,     0,     0,     0,     0,     0,   126,   127,   128,
     129,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   282,     0,   136,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   138,     0,     0,
       0,     0,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    28,    29,    30,    31,    32,
     141,    33,   233,   234,   144,   145,   146,   147,   148,   149,
     150,   110,   151,   152,   153,   154,   155,   156,   157,   111,
     158,   159,   160,   161,   162,   163,   164,   112,   165,   166,
     167,   168,   169,   170,   171,   113,   172,   173,   174,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,     0,   181,     0,   182,     0,   183,
     184,   185,     0,   186,     0,   187,   231,   188,     0,   189,
       0,   121,   122,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   136,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   138,
       0,     0,     0,     0,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
      31,    32,   141,    33,   233,   234,   144,   145,   146,   147,
     148,   149,   150,   110,   151,   152,   153,   154,   155,   156,
     157,   111,   158,   159,   160,   161,   162,   163,   164,   112,
     165,   166,   167,   168,   169,   170,   171,   113,   172,   173,
     174,   231,     0,     0,     2,   322,   121,   122,     0,     0,
       0,     0,     0,     0,   126,   127,   128,   129,     0,   182,
       0,   183,   184,   185,     0,   186,     0,   187,     0,   188,
     323,   189,     0,     0,   324,   325,   326,   327,    10,    11,
       0,   328,     0,     0,   136,     0,   329,   330,     0,     0,
       0,     0,     0,     0,   138,     0,     0,     0,     0,   139,
     331,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,    29,    30,    31,    32,   141,    33,   233,
     234,   144,   145,   146,   147,   148,   149,   150,   110,   151,
     152,   153,   154,   155,   156,   157,   111,   158,   159,   160,
     161,   162,   163,   164,   112,   165,   166,   167,   168,   169,
     170,   171,   113,   172,   173,   174,   231,     0,     0,     2,
     322,   121,   122,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,     0,     0,     0,   183,   184,   185,     0,
     186,     0,   187,     0,   188,   323,   189,     0,     0,   324,
     325,   326,   327,    10,    11,     0,   328,     0,     0,   136,
       0,   329,   330,     0,     0,     0,     0,     0,     0,   138,
       0,     0,     0,     0,   139,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
      31,    32,   141,    33,   233,   234,   144,   145,   146,   147,
     148,   149,   150,   110,   151,   152,   153,   154,   155,   156,
     157,   111,   158,   159,   160,   161,   162,   163,   164,   112,
     165,   166,   167,   168,   169,   170,   171,   113,   172,   173,
     174,   231,     0,     0,     2,   322,   121,   122,     0,     0,
       0,     0,     0,     0,   126,   127,   128,   129,     0,     0,
       0,     0,     0,     0,     0,   186,     0,   187,     0,   188,
     323,   189,     0,     0,   324,   325,   326,   327,    10,    11,
       0,   328,     0,     0,   136,     0,   329,   330,     0,     0,
       0,     0,     0,     0,   138,     0,     0,     0,     0,   139,
     335,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,    29,    30,    31,    32,   141,    33,   233,
     234,   144,   145,   146,   147,   148,   149,   150,   110,   151,
     152,   153,   154,   155,   156,   157,   111,   158,   159,   160,
     161,   162,   163,   164,   112,   165,   166,   167,   168,   169,
     170,   171,   113,   172,   173,   174,   231,     0,     0,     0,
       0,   121,   122,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   187,     0,   188,     0,   189,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   136,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   138,
       0,     0,     0,     0,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
      31,    32,   141,    33,   233,   234,   144,   145,   146,   147,
     148,   149,   150,   110,   151,   152,   153,   154,   155,   156,
     157,   111,   158,   159,   160,   161,   162,   163,   164,   112,
     165,   166,   167,   168,   169,   170,   171,   113,   172,   173,
     174,   231,     0,     0,     0,     0,   121,   122,     0,     0,
       0,     0,     0,     0,   126,   127,   128,   129,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   188,
       0,   189,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   136,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   138,     0,     0,     0,     0,   139,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,    29,    30,    31,    32,   141,    33,   233,
     234,   144,   145,   146,   147,   148,   149,   150,   110,   151,
     152,   153,   154,   155,   156,   157,   111,   158,   159,   160,
     161,   162,   163,   164,   112,   165,   166,   167,   168,   169,
     170,   171,   113,   172,   173,   174,   231,     0,     0,     0,
       0,   121,   122,     0,     0,     0,     0,     0,     0,   126,
     127,   128,   129,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   136,
       0,     0,     0,     0,     0,     0,   455,     0,     0,   138,
       0,     0,     0,   282,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,    30,
      31,    32,   141,    33,   233,   234,   144,   145,   146,   147,
     148,   149,   150,   110,   151,   152,   153,   154,   155,   156,
     157,   111,   158,   159,   160,   161,   162,   163,   164,   112,
     165,   166,   167,   168,   169,   170,   171,   113,   172,   173,
     174,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   556,     0,     0,     0,     0,     0,     0,   282,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   320,     0,
       0,     0,     0,     0,     0,   514,     0,     0,   282,     0,
       0,     0,     0,     0,    77,   524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    77,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,   359,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   560,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    77,   561,     0,     0,   282,     0,
       0,     0,     0,   429,     0,     0,     0,     0,     0,     0,
       0,    77,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   282,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,   435,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,     0,     0,     0,     0,     0,   282,   438,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   282,     0,     0,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,   439,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,     0,     0,     0,     0,     0,     0,     0,   282,   440,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   282,     0,     0,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,     0,     0,
       0,     0,   448,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
       0,     0,     0,     0,     0,     0,     0,     0,   282,     0,
       0,     0,     0,   451,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,   456,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   282,     0,
       0,   457,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,     0,     0,
       0,     0,   469,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   282,   509,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,     0,     0,
       0,     0,   518,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   282,     0,
       0,     0,     0,   545,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,   589,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   282,     0,
       0,     0,     0,   623,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   282,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,     0,     0,     0,     0,   282,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   282,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,    55,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     0,     0,     0,     0,     0,     3,     4,     5,     6,
       7,     8,     9,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    10,    11,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      15,    16,    17,    18
  };

  const short
  WTParser::yycheck_[] =
  {
      25,     0,   130,    86,    87,    40,   245,   369,    93,   125,
      69,   579,   254,    76,    76,    70,    31,    32,    33,    34,
      69,    20,    76,   139,    80,    70,    96,    74,    98,    70,
      69,    80,    80,   116,   117,    78,     3,     4,   200,   607,
      96,    80,    25,    96,    90,    98,    61,    80,    80,    96,
      75,    96,    90,    76,    89,    96,    81,    82,    80,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,    70,   134,    77,    75,   103,   134,
     105,    96,   107,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   164,     2,   158,   159,   160,   161,   162,   163,
     164,   227,    79,    12,    13,    14,    15,    16,    17,    18,
     362,   154,   154,   485,    25,   210,    71,   489,   244,     3,
       4,   247,   248,   134,   250,    80,   134,    36,   134,   162,
     163,   164,    69,   259,   260,    80,    45,    46,    75,    72,
      72,    81,    72,    75,   200,    78,    78,    69,    59,    60,
       0,    81,   200,   279,    76,    80,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   360,   245,
     316,   317,   101,   228,   134,    71,    25,   134,   254,    72,
      76,    76,   134,   496,    80,   498,   254,   134,    81,    76,
     336,    76,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      80,    65,   318,    75,   513,   154,    89,    90,    91,    92,
      93,   443,    95,    96,    95,    96,    38,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      70,     0,    96,   338,    98,    95,    96,   435,    41,    42,
     438,    65,    97,    98,   360,    76,   362,    96,   434,   344,
     436,   437,   360,    70,   362,    77,    25,    81,   444,    52,
     329,    76,    31,    32,    33,    34,    35,    36,    37,    64,
      65,    76,    96,    96,    98,    97,    89,    90,    91,    92,
      93,    71,    95,    96,   105,    47,    48,   473,    95,    96,
      59,    60,   113,    76,   492,    76,    76,    76,    76,    71,
     121,    71,   488,    71,    96,    76,    80,    96,   129,   462,
     463,   464,   510,    82,    83,    84,    85,    86,    87,    88,
     133,    76,    76,   521,   522,    76,   421,   443,   514,   160,
     161,   162,   163,   164,    76,   443,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    76,    69,    69,    80,   326,    53,   155,
      96,    96,   548,    71,    89,    90,    91,    92,    93,    38,
      95,    96,    45,    80,    96,    96,   574,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    96,    96,    26,    51,
     576,   589,    89,    90,    91,    92,    93,   513,    95,   494,
     598,    51,   600,    96,    96,    69,    96,    98,   606,   595,
      96,    96,    96,    96,    96,    96,    76,   615,   155,   617,
      77,    77,    76,    69,    46,   611,   624,   625,    97,    80,
      77,    80,   527,   528,    77,    96,    76,    29,   533,    69,
      69,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    69,    23,
      24,    80,    96,    27,    28,    96,    30,    31,    32,    33,
      34,    96,    96,    96,   569,    39,    40,    80,    80,    43,
      44,    45,    89,    90,    91,    92,    93,    96,    95,    96,
      54,    80,    69,    69,    72,    81,   155,    61,    69,    63,
      69,   134,    77,    69,    77,    77,    80,    71,    69,    69,
      69,    96,    76,    76,    49,    64,    80,    81,    69,    45,
      77,    69,    80,    69,    71,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    96,
      50,   135,    70,    81,   138,    69,    77,   141,    98,   143,
      77,   145,    20,   147,   572,   149,   532,   151,   571,   153,
     154,   155,   535,   157,   558,   159,    81,   161,   604,   163,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,   603,    23,    24,
     593,   513,    27,    28,   613,    30,    31,    32,    33,    34,
     554,   318,   441,    -1,    39,    40,    -1,    -1,    43,    44,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    63,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      -1,    76,    -1,    -1,    -1,    80,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,    -1,    -1,
     135,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,    -1,
     145,    -1,   147,    -1,   149,    -1,   151,    -1,   153,   154,
     155,    -1,   157,    -1,   159,    -1,   161,    -1,   163,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    -1,
      -1,    27,    28,    -1,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    39,    40,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    63,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,   135,
      -1,    -1,   138,    -1,    -1,   141,    -1,   143,    -1,   145,
      -1,   147,    -1,   149,    -1,   151,    -1,   153,   154,   155,
      -1,   157,    -1,   159,    18,   161,    -1,   163,    -1,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    72,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    97,
      -1,   135,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,
      -1,   145,    -1,   147,    -1,   149,    -1,   151,    -1,   153,
     154,   155,    -1,   157,    -1,   159,    18,   161,    -1,   163,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,    71,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,    -1,   135,    -1,    -1,   138,    -1,    -1,   141,
      -1,   143,    -1,   145,    -1,   147,    -1,   149,    -1,   151,
      -1,   153,   154,   155,    -1,   157,    -1,   159,    18,   161,
      -1,   163,    -1,    23,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    -1,    -1,    -1,    76,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,    -1,   135,    -1,    -1,   138,    -1,
      -1,   141,    -1,   143,    -1,   145,    -1,   147,    -1,   149,
      -1,   151,    -1,   153,   154,   155,    -1,   157,    -1,   159,
      18,   161,    -1,   163,    -1,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,    -1,   135,    -1,    -1,
     138,    -1,    -1,   141,    -1,   143,    -1,   145,    -1,   147,
      -1,   149,    -1,   151,    -1,   153,   154,   155,    -1,   157,
      -1,   159,    18,   161,    -1,   163,    -1,    23,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,   135,
      -1,    -1,   138,    -1,    -1,   141,    -1,   143,    -1,   145,
      -1,   147,    -1,   149,    -1,   151,    -1,   153,   154,   155,
      -1,   157,    -1,   159,    18,   161,    -1,   163,    -1,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,    -1,   138,    -1,    -1,   141,    -1,   143,
      -1,   145,    -1,   147,    -1,   149,    -1,   151,    -1,   153,
     154,   155,    -1,   157,    -1,   159,    18,   161,    -1,   163,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,   143,    -1,   145,    -1,   147,    -1,   149,    -1,   151,
      -1,   153,   154,   155,    -1,   157,    -1,   159,    18,   161,
      -1,   163,    -1,    23,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    32,    33,    34,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   143,    -1,   145,    -1,   147,    -1,   149,
      -1,   151,    -1,   153,   154,   155,    -1,   157,    -1,   159,
      18,   161,    -1,   163,    -1,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    31,    32,    33,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,   147,
      -1,   149,    -1,   151,    -1,   153,   154,   155,    -1,   157,
      -1,   159,    18,   161,    -1,   163,    -1,    23,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   147,    -1,   149,    -1,   151,    -1,   153,   154,   155,
      -1,   157,    -1,   159,    18,   161,    -1,   163,    -1,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    76,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   149,    -1,   151,    -1,   153,
     154,   155,    -1,   157,    -1,   159,    18,   161,    -1,   163,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    18,    -1,    -1,    25,    26,    23,    24,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    32,    33,    34,    -1,   151,
      -1,   153,   154,   155,    -1,   157,    -1,   159,    -1,   161,
      51,   163,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    -1,    -1,    61,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    18,    -1,    -1,    25,
      26,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    -1,   153,   154,   155,    -1,
     157,    -1,   159,    -1,   161,    51,   163,    -1,    -1,    55,
      56,    57,    58,    59,    60,    -1,    62,    -1,    -1,    61,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    76,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    18,    -1,    -1,    25,    26,    23,    24,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   157,    -1,   159,    -1,   161,
      51,   163,    -1,    -1,    55,    56,    57,    58,    59,    60,
      -1,    62,    -1,    -1,    61,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    18,    -1,    -1,    -1,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   159,    -1,   161,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,    18,    -1,    -1,    -1,    -1,    23,    24,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    32,    33,    34,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   161,
      -1,   163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,    18,    -1,    -1,    -1,
      -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   163,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,    -1,    71,
      -1,    -1,    -1,    76,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    69,    -1,    -1,    -1,    -1,    -1,    -1,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    73,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    -1,    97,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    97,    81,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    77,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    -1,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    77,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    -1,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    -1,    -1,
      -1,    -1,    81,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    -1,    -1,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    -1,    -1,
      -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    76,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,    -1,    -1,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,     0,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    31,    32,    33,    34,
      35,    36,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    84,
      85,    86,    87,    88
  };

  const unsigned char
  WTParser::yystos_[] =
  {
       0,     0,    25,    31,    32,    33,    34,    35,    36,    37,
      59,    60,    82,    83,    84,    85,    86,    87,    88,   166,
     167,   168,   173,   176,   217,   218,   219,   220,    89,    90,
      91,    92,    93,    95,    96,   174,   175,    78,   202,   178,
     179,    80,    80,    80,    80,    25,    25,   174,   174,   174,
     174,   174,   174,   174,     0,     0,   168,   180,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    38,    77,    97,   216,   241,
      77,   134,   134,    76,    76,   174,     3,     4,   203,   177,
      80,   200,   200,   172,   170,   171,   169,    96,   174,    96,
     174,    75,   181,   154,   241,    70,    96,    70,   216,   241,
     105,   113,   121,   129,   208,   208,     3,     4,    79,   200,
      18,    23,    24,    27,    28,    30,    31,    32,    33,    34,
      39,    40,    43,    44,    45,    54,    61,    63,    71,    76,
      80,    94,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   106,   107,   108,   109,   110,   111,   112,   114,   115,
     116,   117,   118,   119,   120,   122,   123,   124,   125,   126,
     127,   128,   130,   131,   132,   135,   138,   141,   143,   145,
     147,   149,   151,   153,   154,   155,   157,   159,   161,   163,
     174,   204,   205,   206,   207,   208,   209,   210,   211,   221,
     224,   225,   239,   241,   243,   244,   245,   247,   248,   239,
     240,   188,   188,   188,    76,    76,    76,    76,   174,    52,
     182,   241,    96,   241,   241,   208,   208,    80,   154,    76,
      76,    18,    69,    96,    97,   243,   244,   245,    71,    71,
      71,    71,    96,   221,    76,    76,    76,    76,    76,    96,
      76,    95,    96,   243,   222,    71,    80,    71,    76,    80,
      80,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   201,   225,    69,    75,
     134,    96,    76,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    69,    72,    75,    78,   134,    69,
      81,   239,    26,    51,    55,    56,    57,    58,    62,    67,
      68,    81,   189,   217,    81,    81,    80,    53,   183,   155,
     243,   241,    96,    96,   154,    69,    96,    96,    96,    96,
      45,   243,   245,   246,   247,    96,   243,   243,   243,    77,
     224,    96,   223,    98,    95,    96,    72,    81,   243,   249,
     250,   243,    26,   212,   213,   243,    96,    77,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
      96,   243,   243,   248,    96,    96,    51,    51,    96,   133,
     174,    96,    96,   217,    96,    69,   243,    76,   200,    81,
     155,    77,    77,   241,    76,    77,    69,    46,    77,    77,
      77,    80,    81,   224,    80,    77,    77,    96,    81,    81,
     250,    81,    76,    29,   214,    69,    77,    79,    69,    80,
      96,    96,    96,    96,    96,   241,    80,    69,    80,    81,
      96,   186,   187,    80,    69,    69,   155,   243,   221,   242,
     243,   243,   221,    69,   228,   249,    81,   243,    75,   134,
      74,    96,   215,    81,   192,    69,    80,    69,    80,   208,
     208,   208,    69,   190,   191,   134,    77,    81,   243,    77,
      41,    42,   229,    69,    73,   227,    80,    81,    81,   243,
     250,    77,    77,   221,    81,   193,   241,   192,   192,    69,
      69,    69,    65,    96,    98,   196,   197,   198,   199,    96,
      98,   194,   195,    96,   184,    81,    69,   221,    76,   246,
     243,    49,   233,    64,   234,   235,    69,   221,   221,    96,
      81,    81,    96,   197,   241,    81,   198,    69,    69,   134,
      81,   134,    80,   243,    77,   226,    45,   230,    97,    98,
      65,   235,   238,   213,    69,    69,   241,   195,   187,    77,
     221,    47,    48,   232,   243,    50,   231,    71,    70,   186,
      70,    81,    69,   221,   233,   243,    77,    98,   221,    70,
     221,   185,   229,   230,   221,    70,   186,   236,   243,   231,
     221,    70,   221,    81,    77,   237,   221,   221
  };

  const unsigned char
  WTParser::yyr1_[] =
  {
       0,   165,   166,   166,   167,   167,   168,   168,   169,   168,
     170,   168,   171,   168,   172,   168,   173,   173,   173,   173,
     173,   173,   173,   174,   174,   175,   175,   175,   175,   175,
     175,   177,   176,   178,   176,   179,   176,   180,   176,   181,
     182,   182,   183,   184,   185,   183,   186,   186,   187,   187,
     188,   188,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   190,   189,   191,   189,   192,   192,
     193,   194,   194,   195,   195,   196,   196,   197,   197,   198,
     198,   198,   199,   199,   201,   200,   202,   202,   203,   203,
     203,   203,   204,   204,   204,   204,   205,   205,   205,   205,
     206,   206,   206,   206,   207,   207,   207,   207,   208,   208,
     208,   208,   209,   209,   209,   209,   210,   210,   210,   210,
     211,   211,   211,   211,   212,   212,   213,   213,   213,   214,
     215,   214,   216,   216,   217,   217,   217,   218,   218,   218,
     218,   218,   218,   219,   219,   220,   220,   220,   222,   221,
     223,   221,   224,   224,   224,   225,   225,   225,   225,   225,
     225,   225,   225,   225,   225,   225,   226,   225,   227,   225,
     225,   225,   228,   225,   229,   229,   229,   230,   230,   231,
     231,   232,   232,   232,   233,   233,   234,   234,   236,   235,
     237,   235,   235,   235,   238,   238,   239,   239,   239,   239,
     240,   240,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     242,   242,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   243,   243,   243,   243,   243,
     243,   243,   243,   243,   243,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   245,   245,   245,   245,   245,
     245,   245,   245,   245,   246,   246,   247,   248,   248,   249,
     249,   250,   250
  };

  const signed char
  WTParser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     2,     1,     1,     0,     5,
       0,     5,     0,     5,     0,     5,     2,     2,     2,     2,
       2,     2,     4,     1,     2,     1,     1,     1,     1,     1,
       1,     0,     4,     0,     3,     0,     3,     0,     6,     0,
       0,     4,     0,     0,     0,    11,     1,     3,     0,     1,
       0,     2,     2,     3,     5,     6,     4,     6,     4,     3,
       5,     5,     5,     4,     0,     6,     0,     6,     0,     2,
       3,     1,     3,     1,     1,     1,     2,     1,     1,     2,
       3,     2,     2,     3,     0,     6,     0,     3,     2,     2,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     5,     5,     6,     0,
       0,     3,     2,     3,     2,     2,     1,     3,     3,     4,
       4,     4,     4,     2,     3,     4,     4,     3,     0,     4,
       0,     5,     0,     1,     2,     1,     1,     2,     2,     2,
       3,     5,     5,     5,     7,     9,     0,    14,     0,    11,
       6,     5,     0,     9,     0,     2,     6,     0,     2,     0,
       2,     0,     1,     1,     0,     1,     1,     2,     0,     6,
       0,     8,     4,     6,     0,     3,     2,     3,     2,     4,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       0,     1,     2,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     6,     7,     4,     3,     4,     4,     6,     1,
       4,     3,     6,     4,     4,     3,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     3,     3,     3,     3,
       3,     4,     3,     2,     0,     1,     1,     3,     3,     1,
       2,     5,     4
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const WTParser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "OPT_DSS", "OPT_CSS",
  "TYPE_CHAR", "TYPE_BOOL", "TYPE_HANDLE", "TYPE_I8", "TYPE_U8",
  "TYPE_I16", "TYPE_U16", "TYPE_I32", "TYPE_U32", "TYPE_I64", "TYPE_U64",
  "TYPE_F32", "TYPE_F64", "KW_SEQ", "TYPE_STRING", "TYPE_FILE", "TYPE_DIR",
  "TYPE_SOCKET", "KW_TRUE", "KW_FALSE", "KW_FUNCTION", "KW_EXCEPTION",
  "KW_RAISE", "KW_RAISENEAR", "KW_FINALLY", "KW_RETURN", "KW_MAIN",
  "KW_CTOR", "KW_DTOR", "KW_GLOBAL", "KW_IMPORT", "KW_EXPORT",
  "KW_DECLARE", "KW_MUTABLE", "KW_DO", "KW_IF", "KW_ELSE", "KW_ELIF",
  "KW_FOR", "KW_FOREACH", "KW_WHILE", "KW_IN", "KW_INCLUSIVE",
  "KW_EXCLUSIVE", "KW_REVERSE", "KW_WHICH", "KW_RECORD", "KW_PRE",
  "KW_POST", "KW_ASSERT", "KW_LIMITED", "KW_PRIVATE", "KW_OPERATOR",
  "KW_ALIAS", "KW_PURE", "KW_IMPURE", "KW_OLD", "KW_DATATYPE", "KW_SWITCH",
  "KW_CASE", "KW_DEFAULT", "KW_BREAK", "KW_TYPE", "KW_ENUM", "SEMICOLON",
  "COLON", "COLONCOLON", "DOT", "DOTDOT", "DOTDOTDOT", "ASSIGN", "LPAR",
  "RPAR", "LBRACKET", "RBRACKET", "LBRACE", "RBRACE", "META_AUTHOR",
  "META_TITLE", "META_VERSION", "META_COPYRIGHT", "META_ID",
  "META_COMMENT", "META__CUSTOM", "PREDEF_FILE", "PREDEF_LINE",
  "PREDEF_DATE", "PREDEF_TIME", "PREDEF_DATETIME", "CHARLIT", "STRINGLIT",
  "IDENTIFIER", "TYPENAME", "SPECIALIDENT", "FLOATNUMBER", "DOUBLENUMBER",
  "I8DEC", "U8DEC", "I16DEC", "U16DEC", "I32DEC", "U32DEC", "I64DEC",
  "U64DEC", "I8HEX", "U8HEX", "I16HEX", "U16HEX", "I32HEX", "U32HEX",
  "I64HEX", "U64HEX", "I8BIN", "U8BIN", "I16BIN", "U16BIN", "I32BIN",
  "U32BIN", "I64BIN", "U64BIN", "I8OCT", "U8OCT", "I16OCT", "U16OCT",
  "I32OCT", "U32OCT", "I64OCT", "U64OCT", "UNBOUNDOPERATOR", "COMMA",
  "OP_LEFT03", "OP_LORELSE", "OP_RIGHT03", "OP_LEFT04", "OP_LANDTHEN",
  "OP_RIGHT04", "OP_LEFT05", "OP_RIGHT05", "OP_LEFT06", "OP_RIGHT06",
  "OP_LEFT07", "OP_RIGHT07", "OP_LEFT08", "OP_RIGHT08", "OP_LEFT09",
  "OP_RIGHT09", "OP_LEFT10", "OP_RIGHT10", "OP_LEFT11", "LANGLEBRACKET",
  "RANGLEBRACKET", "OP_RIGHT11", "OP_LEFT12", "OP_RIGHT12", "OP_LEFT13",
  "OP_RIGHT13", "OP_LEFT14", "OP_RIGHT14", "OP_LEFT15", "OP_RIGHT15",
  "$accept", "start", "entities", "entity", "$@1", "$@2", "$@3", "$@4",
  "metadata", "string", "stringlit", "block", "$@5", "$@6", "$@7", "$@8",
  "attributes", "precond", "postcond", "@9", "@10", "identlist",
  "identlist_opt", "declarations", "declaration", "@11", "@12",
  "recordfields", "recordfield", "enumerators", "enumerator",
  "datatypeconses", "datatypeconsname", "datatypecons",
  "datatypecons_builder", "exceptioncompound", "$@13", "throptions",
  "throptionlist", "integer8", "unsigned8", "integer16", "unsigned16",
  "integer32", "unsigned32", "integer64", "unsigned64", "ehandlers",
  "ehandlerlist", "finally", "$@14", "functionargument",
  "functionsignature", "funcsig_start", "funcsig_args", "funcsig_rets",
  "compound", "$@15", "$@16", "statements", "statement", "@17", "@18",
  "$@19", "elsestatement", "foreach_while", "foreach_which",
  "inclusive_opt", "reverse_opt", "switchcases", "switchcase", "@20",
  "@21", "default_opt", "variabledeclaration", "variabledeclarations",
  "type", "expression_opt", "expression", "funccallexpr", "lvalue",
  "assignment_opt", "assignment", "assignment_builder", "fieldassigns",
  "fieldassign", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  WTParser::yyrline_[] =
  {
       0,   301,   301,   307,   316,   330,   345,   351,   358,   357,
     370,   369,   382,   381,   394,   393,   407,   414,   421,   428,
     435,   442,   449,   459,   466,   476,   483,   489,   495,   501,
     507,   515,   515,   524,   524,   532,   532,   541,   540,   571,
     578,   583,   592,   598,   602,   597,   617,   625,   636,   641,
     650,   655,   669,   675,   681,   689,   705,   721,   737,   753,
     760,   768,   776,   784,   792,   791,   808,   807,   826,   831,
     840,   849,   856,   865,   872,   881,   888,   897,   903,   911,
     918,   926,   934,   942,   951,   951,   962,   967,   975,   982,
     989,   996,  1005,  1012,  1019,  1026,  1035,  1042,  1049,  1056,
    1065,  1072,  1079,  1086,  1095,  1102,  1109,  1116,  1125,  1132,
    1139,  1146,  1155,  1162,  1169,  1176,  1185,  1192,  1199,  1206,
    1215,  1222,  1229,  1236,  1246,  1251,  1260,  1267,  1276,  1287,
    1292,  1292,  1302,  1309,  1318,  1326,  1334,  1344,  1351,  1358,
    1365,  1372,  1379,  1388,  1395,  1404,  1411,  1418,  1427,  1427,
    1435,  1435,  1447,  1452,  1462,  1474,  1480,  1486,  1492,  1506,
    1512,  1518,  1525,  1532,  1538,  1544,  1551,  1550,  1567,  1566,
    1582,  1588,  1595,  1594,  1608,  1613,  1619,  1628,  1633,  1642,
    1647,  1656,  1661,  1667,  1676,  1681,  1689,  1696,  1706,  1705,
    1721,  1720,  1736,  1743,  1754,  1759,  1767,  1784,  1801,  1808,
    1820,  1827,  1836,  1842,  1848,  1854,  1860,  1866,  1872,  1878,
    1884,  1890,  1896,  1902,  1908,  1914,  1920,  1926,  1932,  1939,
    1948,  1953,  1961,  1968,  1975,  1989,  1995,  2001,  2008,  2014,
    2020,  2027,  2034,  2041,  2047,  2053,  2059,  2065,  2071,  2077,
    2083,  2089,  2095,  2101,  2107,  2113,  2120,  2127,  2134,  2140,
    2147,  2154,  2162,  2170,  2178,  2188,  2194,  2200,  2207,  2214,
    2221,  2228,  2235,  2242,  2249,  2256,  2263,  2270,  2277,  2284,
    2291,  2298,  2305,  2312,  2319,  2326,  2333,  2340,  2347,  2354,
    2361,  2368,  2375,  2382,  2389,  2396,  2403,  2410,  2417,  2424,
    2431,  2438,  2445,  2452,  2459,  2466,  2473,  2480,  2487,  2494,
    2501,  2508,  2515,  2522,  2529,  2536,  2543,  2550,  2557,  2564,
    2571,  2578,  2585,  2592,  2599,  2608,  2615,  2623,  2630,  2637,
    2644,  2651,  2686,  2693,  2703,  2708,  2716,  2725,  2731,  2740,
    2747,  2756,  2764
  };

  void
  WTParser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  WTParser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  WTParser::symbol_kind_type
  WTParser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164
    };
    // Last valid token kind.
    const int code_max = 419;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 9 "parser.y"
} // wtparser
#line 5653 "parser.tab.cpp"

